<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Controller_Cli extends Zend_Controller_Action
{

    private $stdin;

    function preDispatch()
    {
        $this->flush();
    }

    function init()
    {
        $this->_helper->ViewRenderer->setNoRender();
    }

    public function writeLine($string, $new_line = true)
    {
        echo $string;
        echo $new_line ? PHP_EOL : '';
    }

    public function confirmYes($message)
    {
        echo $message, ' [y/N] ';
        $answer = $this->readLine('N');

        return $answer == 'y';
    }

    public function readLine($default = '')
    {
        $this->flush();

        if (empty ($this->stdin)) {
            $this->stdin = fopen('php://stdin', 'r');
        }

        $line = fgets($this->stdin);
        $line = trim($line);

        if ('' == $line) {
            $line = $default;
        }

        return $line;
    }

    function flush()
    {
        while (ob_get_level()) {
            ob_end_flush();
        }
    }
}
