<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\Research\ExpositionRepository;
use Rc\Domain\Repository\UserRepository;

class PortalsController extends BasicControllerAction
{

    public function init()
    {
        $this->initPortal();
    }

    public function indexAction()
    {
        $portal = $this->_getRequestedPortal();
        $this->view->assign('portal', $portal);
        $this->view->assign('researches', ExpositionRepository::findByPortal($portal, ['page' => $this->_getParam('p', 0), 'limit' => 6]));
        $this->view->assign('researchPager', $this->_getParam('p', 0));
    }

    public function issueAction()
    {
        $issue = $this->_getRequestedIssue();

        $this->view->assign('issue', $issue);
    }

    public function requestMembershipAction()
    {
        $this->_disableView();

        $user = Identity::getUser();
        $portalIds = $user->getPortalIds() + $user->getPendingPortalIds();
        $portalIds[] = $this->_getRequestedPortal()->getId();

        $this->_handlePortalMembership($user, array_unique($portalIds));

        UserRepository::persist($user);
    }

}
