<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\UserRepository;

class SettingsController extends BasicControllerAction
{

    public function init()
    {
        $this->initPortal();
    }

    public function indexAction()
    {
        $this->forward('edit');
    }

    public function editAction()
    {
        $user = Identity::getUser();
        $settings = $user->getSettings();

        $settingsForm = $this->_getForm()->setDefaultsFrom($user)->setDefaultsFrom($settings);
        if ($this->_getParam('type') == 'settings' && $settingsForm->isPostAndValid()) {
            $user->setValues($settingsForm->getValues());
            $settings->setValues($settingsForm->getValues());
            UserRepository::persist($user);
        }
        $this->view->settingsForm = $settingsForm;

        $changePasswordForm = SettingsFormGenerator::getChangePassword();
        if ($this->_getParam('type') == 'password' && $changePasswordForm->isPostAndValid()) {
            $user->setValues($changePasswordForm->getValues());
            UserRepository::persist($user);
        }
        $this->view->changePasswordForm = $changePasswordForm;
    }

}

?>