<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition\ToolTemplate;
use Rc\Domain\Model\Research\Exposition\Weave\Tool;
use Rc\Domain\Repository\Research\Exposition\ToolTemplateRepository;
use Rc\Domain\Repository\Research\Exposition\Weave\ToolRepository;

class ToolController extends BasicControllerAction
{

    public function editTemplateAction()
    {
        $exposition = $this->_getRequestedResearch();
        $toolTemplate = ToolTemplateRepository::findByNameAndResearch($this->_getParam('tool'), $exposition);
        if (!isset($toolTemplate)) {
            $tool = ToolFactory::buildByName($this->_getParam('tool'));
            $tool->setWidth(Tool::DEFAULT_THUMB_WIDTH);
            $tool->setHeight(Tool::DEFAULT_THUMB_HEIGHT);
            $tool->setOpacity(Tool::CSS_OPACITY_VISIBLE);
            $tool->setPosition(Tool::POSITION_CENTER_CENTER);

            $toolTemplate = new ToolTemplate($tool, $exposition);
        } else {
            $tool = $toolTemplate->getTool();
        }

        $form = $this->_getForm($tool, $exposition)->setDefaultsFrom($tool);
        if ($form->isPostAndValid()) {
            $toolTemplate->updateToolValues($form->getValues());
            ToolTemplateRepository::persist($toolTemplate);

            $this->_disableView();
        } else {
            $this->view->form = $form;
            $this->view->item = $tool;
        }
    }

}

?>