<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Service\ZencoderService;

/**
 * @category  SAR.RC
 */
class ZencoderController extends BasicControllerAction
{

    public function init()
    {
        $this->_disableView();
    }

    public function notifyAction()
    {
        $master = $this->_getParam('master');
        $format = $this->_getParam('format');

        $response = json_decode($this->_request->getRawBody(), true);
        if ($response['job']['state'] != 'finished') {
            trigger_error('transcoding job failed for job id ' . $response['job']['id'], E_USER_WARNING);

            ZencoderService::failRemote($master);
            die('error');
        }

        $this->notifyZencoderAboutSuccess();

        foreach ($response['outputs'] as $output) {
            ZencoderService::ingestRemote($master, $format, $output['url']);
        }
    }

    protected function notifyZencoderAboutSuccess()
    {
        echo 'OK';
        session_write_close();
        fastcgi_finish_request();
    }

}
