<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class ReportFormGenerator extends BasicFormGenerator
{

    public static function getAdd()
    {
        $form = CommentFormGenerator::getAdd();
        $form->setTitle('dialog.report.add');

        return $form;
    }

    public static function getRemove()
    {
        $form = CommentFormGenerator::getRemove();
        $form->setTitle('dialog.report.remove');

        return $form;
    }

    public static function getConvert(Report $report = null)
    {
        $form = new DefaultForm();
        $form->setTitle('dialog.report.convert', $report);

        $form->addElement('html', 'info', [
            'value' => static::_getTranslate()->translate('info.report.convert'),
        ])
            ->addElement('hidden', 'confirmation', [
                'value'    => 'confirmation',
                'required' => true,
            ]);

        $form->addCancelButton('no')->addSubmitButton('yes');

        return $form;
    }

}

?>