<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition\Weave\Tool\EmbedTool;

class My_Validate_EmbedUrl extends Zend_Validate_Abstract
{

    const INVALID = 'invalid';

    /**
     * @var array
     */
    protected $_messageTemplates = [
        self::INVALID => "The url could not be parsed. Please check if you have entered a valid url.",
    ];

    /**
     * @param  mixed $value
     * @return boolean
     */
    public function isValid($value)
    {
        $this->_setValue($value);

        $result = EmbedTool::processUrl($value);
        if (!$result['url'] || !$result['urlApi']) {
            $this->_error(self::INVALID);
            return false;
        }

        return true;
    }

}
