<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Validate_SimpleDate extends Zend_Validate_Date
{

    /**
     * Defined by Zend_Validate_Interface
     *
     * Returns true if $value is a valid date of the format YYYY-MM-DD
     * If optional $format or $locale is set the date format is checked
     * according to Zend_Date, see Zend_Date::isDate()
     *
     * @param  string|array|Zend_Date $value
     * @return boolean
     */
    public function isValid($value)
    {
        $this->_setValue($value);

        if (!preg_match('~^(\d{4})|(\d{2}.\d{2}.\d{4})|(\d{2}.\d{2}.\d{2})$~', $value, $matches)) {
            $this->_error(self::INVALID_DATE);
            return false;
        }

        return true;
    }
}
