<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Validate_Url extends Zend_Validate_Abstract
{

    const INVALID = 'invalid';
    const INVALID_SCHEME = 'invalidScheme';

    /**
     * @var array
     */
    protected $_messageTemplates = [
        self::INVALID        => "'%value%' is no valid url!",
        self::INVALID_SCHEME => "Please provide an url beginning with https://",
    ];

    /**
     * @param  mixed $value
     * @return boolean
     */
    public function isValid($value)
    {
        $this->_setValue($value);

        if (!filter_var($value, FILTER_VALIDATE_URL)) {
            $this->_error(self::INVALID);
            return false;
        } elseif (substr($value, 0, 8) != 'https://') {
            $this->_error(self::INVALID_SCHEME);
            return false;
        }
        return true;
    }

}
