<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\ModelInterface;
use Rc\Domain\Model\Research;
use Rc\Domain\Repository\MongoRepository;

class EntityFeed extends MySqlEntity
{

    /**
     * @var int
     */
    protected $id;

    /**
     * @var string
     */
    protected $targetid;

    /**
     * @var int
     */
    protected $userid;

    /**
     * @var int
     */
    protected $receiveShared = 1;

    /**
     * @var int
     */
    protected $receiveEdited = 1;

    /**
     * @var int
     */
    protected $receiveCommented = 1;

    /**
     * @var int
     */
    protected $receivePublished = 1;

    /**
     * @var ModelInterface
     */
    private $target;

    /**
     * @var \Rc\Domain\Model\User
     */
    private $user;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     * @return void
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return int
     */
    public function getReceiveShared()
    {
        return $this->receiveShared;
    }

    /**
     * @param int $receiveShared
     * @return void
     */
    public function setReceiveShared($receiveShared)
    {
        $this->receiveShared = $receiveShared;
    }

    /**
     * @return int
     */
    public function getReceiveEdited()
    {
        return $this->receiveEdited;
    }

    /**
     * @param int $receiveEdited
     * @return void
     */
    public function setReceiveEdited($receiveEdited)
    {
        $this->receiveEdited = $receiveEdited;
    }

    /**
     * @return int
     */
    public function getReceiveCommented()
    {
        return $this->receiveCommented;
    }

    /**
     * @param int $receiveCommented
     * @return void
     */
    public function setReceiveCommented($receiveCommented)
    {
        $this->receiveCommented = $receiveCommented;
    }

    /**
     * @return int
     */
    public function getReceivePublished()
    {
        return $this->receivePublished;
    }

    /**
     * @param int $receivePublished
     * @return void
     */
    public function setReceivePublished($receivePublished)
    {
        $this->receivePublished = $receivePublished;
    }

    /**
     * @return string
     */
    public function getTargetId()
    {
        return $this->targetid;
    }

    /**
     * @param string $targetid
     * @return void
     */
    public function setTargetid($targetid)
    {
        $this->targetid = $targetid;
    }

    /**
     * @return int
     */
    public function getUserid()
    {
        return $this->userid;
    }

    /**
     * @param int $userid
     * @return void
     */
    public function setUserid($userid)
    {
        $this->userid = $userid;
    }

    /**
     * @return ModelInterface
     */
    public function getTarget()
    {
        if (!isset($this->target)) {
            $this->target = MongoRepository::findById($this->targetid);
        }
        return $this->target;
    }

    /**
     * @param Research $target
     */
    public function setTarget($target)
    {
        $this->target = $target;
        $this->targetid = $target->getId();
    }

    /**
     * @return \Rc\Domain\Model\User
     */
    public function getUser()
    {
        if (!isset($this->user)) {
            $this->user = \Rc\Domain\Repository\UserRepository::findById($this->userid);
        }
        return $this->user;
    }

    /**
     * @param \Rc\Domain\Model\User $user
     * @return void
     */
    public function setUser($user)
    {
        $this->user = $user;
        $this->userid = $user->getId();
    }
}