<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

/**
 * @deprecated
 */
class Settings extends MySqlEntity
{

    protected $id;

    protected $userid;

    protected $language;

    protected $announcements;

    protected $digest;

    protected $uploadNotification;

    protected $messageNotification;

    protected $madek;

    protected $hideProfile;

    /**
     * @var bool
     */
    protected $hideNavigationTooltip;

    function __construct($data = null)
    {
        static::_setDefaultValues();
        parent::__construct($data);
    }

    function getId()
    {
        return $this->id;
    }

    function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    public function getHideProfile()
    {
        return $this->isProfileHidden();
    }

    public function setHideProfile($flag)
    {
        $this->hideProfile = $flag;
    }

    public function isProfileHidden()
    {
        $user = $this->getUser();
        if (!$user->isLimitedUser() || $user->isInvolved()) {
            return false;
        }

        return $this->hideProfile;
    }

    public function setUser(\Rc\Domain\Model\User $user)
    {
        $this->userid = $user->getId();
        return $this;
    }

    /**
     * @return \Rc\Domain\Model\User
     */
    public function getUser()
    {
        return UserRepository::findById($this->userid);
    }

    public function getUserid()
    {
        return $this->userid;
    }

    public function setUserid($userid)
    {
        $this->userid = $userid;
        return $this;
    }

    public function getLanguage()
    {
        return $this->language;
    }

    public function setLanguage($language)
    {
        $this->language = $language;
        return $this;
    }

    public function getAnnouncements()
    {
        return $this->announcements;
    }

    public function setAnnouncements($announcements)
    {
        $this->announcements = $announcements;
        return $this;
    }

    public function getDigest()
    {
        return $this->digest;
    }

    public function setDigest($digest)
    {
        $this->digest = $digest;
    }

    public function getUploadNotification()
    {
        return $this->uploadNotification;
    }

    public function setUploadNotification($uploadNotification)
    {
        $this->uploadNotification = $uploadNotification;
        return $this;
    }

    public function getMessageNotification()
    {
        return $this->messageNotification;
    }

    public function setMessageNotification($messageNotification)
    {
        $this->messageNotification = $messageNotification;
        return $this;
    }

    /**
     * @return boolean
     */
    public function getHideNavigationTooltip()
    {
        return $this->hideNavigationTooltip;
    }

    /**
     * @param boolean $hideNavigationTooltip
     * @return void
     */
    public function setHideNavigationTooltip($hideNavigationTooltip)
    {
        $this->hideNavigationTooltip = $hideNavigationTooltip;
    }

    protected function getMadek()
    {
        return $this->madek;
    }

    protected function setMadek($madek)
    {
        $this->madek = $madek;
    }

    protected function _setDefaultValues()
    {
        $this->setLanguage(config('app.lang'));
        $this->setAnnouncements(true);
        $this->setDigest(true);
        $this->setUploadNotification(true);
        $this->setMessageNotification(true);
        $this->setMadek(false);
        $this->setHideProfile(false);
        $this->setHideNavigationTooltip(false);

        return $this;
    }

}

?>