<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class AnnouncementRepository extends MySqlRepository
{

    protected static $orderBy = [
        'field' => 'created',
        'order' => 'DESC',
    ];

    /**
     * @param int $page
     * @param int $limit
     * @param array $orderBy
     * @return Announcement[]
     */
    static public function findAllApproved($page = 0, $limit = null, $orderBy = null)
    {
        return self::_findBy('approved', true, $page, $limit, $orderBy);
    }

    /**
     * @param Newsletter $newsletter
     * @param int $page
     * @param int $limit
     * @param array $orderBy
     * @return Announcement
     */
    public static function findOneByNewsletter($newsletter, $page = 0, $limit = null, $orderBy = null)
    {
        $result = self::_findBy('newsletterid', $newsletter->getId(), $page, $limit, $orderBy);
        if (empty($result)) {
            return null;
        }

        return current($result);
    }
}
