<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research;
use Rc\Domain\Model\User;

class EntityFeedRepository extends MySqlRepository
{

    /**
     * @param User $user
     * @return EntityFeed[]
     */
    public static function findByUser(User $user)
    {
        return self::_findBy('userid', $user->getId());
    }

    /**
     * @param User $user
     * @param Research $target
     * @return EntityFeed|null
     */
    public static function findOneByUserAndTarget(User $user, Research $target)
    {
        return self::findOneByUserAndTargetId($user, $target->getId());
    }

    /**
     * @param User $user
     * @param int $targetId
     * @return EntityFeed|null
     */
    public static function findOneByUserAndTargetId(User $user, $targetId)
    {
        $results = self::_findBy(['userid', 'targetid'], [$user->getId(), $targetId]);
        if (!empty($results)) {
            return current($results);
        } else {
            return null;
        }
    }
}
