<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class KeywordRepository extends MySqlRepository
{

    public static function findByPrefix($prefix, $limit = null, $orderBy = null)
    {
        $result = static::_query('
            SELECT
                name
            FROM
                ' . static::_getJoinedTables() . '
            WHERE
                name LIKE "' . static::_escape($prefix) . '%"
            ORDER BY
                ' . static::_getValidOrderBy($orderBy) . '
            LIMIT
                ' . static::_getLimit(0, $limit) . '
        ');

        $retVal = [];
        while ($row = $result->fetch_object()) {
            $retVal[] = $row->name;
        }
        return $retVal;
    }

    public static function addKeywords($keywords)
    {
        $values = [];
        foreach (explode(',', $keywords) as $keyword) {
            if (empty($keyword)) {
                continue;
            }
            $values[] = '("' . static::_escape($keyword) . '")';
        }
        if (empty($values)) {
            return;
        }
        static::_query('INSERT IGNORE ' . static::_getJoinedTables() . '(name) VALUES ' . implode(',', $values));
    }

}

?>