<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class UserFeedRepository extends MySqlRepository
{

    /**
     * @param \Rc\Domain\Model\User $user
     * @return UserFeed[]
     */
    public static function findByUser($user)
    {
        return self::_findBy('userid', $user->getId());
    }

    /**
     * @param \Rc\Domain\Model\User $user
     * @param \Rc\Domain\Model\User $target
     * @return UserFeed|null
     */
    public static function findOneByUserAndTarget($user, $target)
    {
        return self::findOneByUserAndTargetId($user, $target->getId());
    }

    /**
     * @param \Rc\Domain\Model\User $user
     * @param int $targetId
     * @return UserFeed|null
     */
    public static function findOneByUserAndTargetId($user, $targetId)
    {
        $results = self::_findBy(['userid', 'targetid'], [$user->getId(), $targetId]);
        if (!empty($results)) {
            return current($results);
        } else {
            return null;
        }
    }
}
