<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Form_Decorator_Error extends Zend_Form_Decorator_Abstract
{

    public function render($content)
    {
        $element = $this->getElement();
        if (!$element instanceof Zend_Form_Element && !$element instanceof DefaultForm) {
            return $content;
        }

        if (null === $element->getView()) {
            return $content;
        }

        $messages = $element->getMessages();
        if (empty($messages)) {
            return $content;
        }

        $output = '';
        if ($element instanceof Zend_Form_Element) {
            $output = $element->getView()->formError(
                $messages, $element->getAttribs()
            );
        } else if ($element instanceof DefaultForm && $element->hasErrors()) {
            $element->addJQueryParam('title', $element->getView()->getHelper('FormError')->ContainerError($element->getJQueryParam('title')));
        }

        $separator = $this->getSeparator();
        switch ($this->getPlacement()) {
            case (self::PREPEND):
                return $output . $separator . $content;
            case (self::APPEND):
            default:
                return $content . $separator . $output;
        }
    }

}

?>