<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_View_Helper_Date extends Zend_View_Helper_Abstract
{

    public function date($date)
    {
        if (empty($date)) {
            $retVal = null;
        } elseif ($date instanceof DateTime) {
            $retVal = $date->format(Zend_Registry::get('Zend_Locale')->getDefaultDateFormatForPhp());
        } else {
            $retVal = date(Zend_Registry::get('Zend_Locale')->getDefaultDateFormatForPhp(), $date);
        }

        return $retVal;
    }

    public function time($time)
    {
        if (empty($time)) {
            $retVal = null;
        } else {
            $retVal = date('H:i', $time);
        }

        return $retVal;
    }

    public function dateTime($dateTime)
    {
        if (empty($dateTime)) {
            $retVal = null;
        } elseif ($dateTime instanceof DateTime) {
            $retVal = $dateTime->format(Zend_Registry::get('Zend_Locale')->getDefaultDateTimeFormatForPhp());
        } else {
            $retVal = date(Zend_Registry::get('Zend_Locale')->getDefaultDateTimeFormatForPhp(), $dateTime);
        }

        return $retVal;
    }

}

?>