<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Zend_View_Helper_FormAwardingInstitutions extends Zend_View_Helper_FormElement
{

    public function formAwardingInstitutions($name, $value = null, $attribs = null)
    {
        $info = $this->_getInfo($name, $value, $attribs);
        extract($info); // name, value, attribs, options, listsep, disable
        $name = substr($name, 0, -2);

        if (empty($value)) {
            $value = [
                ['institution' => null, 'country' => null],
            ];
        }

        $output = '';
        $class = [false => 'ui-icon-plus form-add-field"', true => 'ui-icon-minus form-remove-field'];
        foreach ($value as $key => $entry) {
            if ($key == 0) {
                $additionalClass = [];
            } else {
                $additionalClass = ['class' => 'form-additional-multi-field'];
            }
            $output .= $this->view->formSelect($name . '[' . $key . '][country]', $entry['country'], ['style' => 'width:100px'] + $additionalClass, $attribs['countries']) .
                $this->view->formText($name . '[' . $key . '][institution]', $entry['institution'], ['style' => 'width:255px;margin-left:5px'] + $additionalClass) .
                '<span class="ui-icon ' . $class[$key > 0] . '"></span>';
        }
        return $output;
    }

}

?>