<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Zend_View_Helper_FormError extends Zend_View_Helper_FormElement
{
    const ERROR_IMG_URL = '/rc/images/exclamation.png';

    public function FormError($value, $attribs = null)
    {
        unset($attribs['id']);
        $xhtml = '<img src="' . self::ERROR_IMG_URL . '" ' . $this->_htmlAttribs($attribs) . 'data-title="<ul><li>' . implode('<li>', $value) . '</ul>"
            class="error" onmouseover="showTitle(this)" onmouseout="hideTitle()"/>';

        return $xhtml;
    }

    public function ContainerError($title = null, $attribs = null)
    {
        unset($attribs['id']);
        $xhtml = '<img src="' . self::ERROR_IMG_URL . '" class="error" ' . $this->_htmlAttribs($attribs) . '/>';

        if ($title) {
            $xhtml .= ' <span style="color:red">' . $this->view->translate($title) . '</span>';
        }

        return $xhtml;
    }

}

?>