<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Zend_View_Helper_FormRange extends Zend_View_Helper_FormElement
{

    public function formRange($name, $value = null, $attribs = null)
    {
        if (empty($value)) {
            $value = (int)$attribs['min'];
        }

        $info = $this->_getInfo($name, $value, $attribs);
        extract($info); // name, value, attribs, options, listsep, disable
        // is it disabled?
        $disabled = '';
        if ($disable) {
            $disabled = ' disabled="disabled"';
        }

        // XHTML or HTML end tag?
        $endTag = ' />';
        if (($this->view instanceof Zend_View_Abstract) && !$this->view->doctype()->isXhtml()) {
            $endTag = '>';
        }

        if (!empty($attribs['update'])) {
            $attribs['oninput'] = '$(this).next("span").text($(this).val())';
            unset($attribs['update']);
        }

        // render the element
        $xhtml = '<span class="input-container"><input type="range" style="float:left"'
            . ' name="' . $this->view->escape($name) . '"'
            . ' id="' . $this->view->escape($id) . '"'
            . ' value="' . $this->view->escape($value) . '"'
            . $disabled
            . $this->_htmlAttribs($attribs)
            . $endTag . '<span>' . $this->view->escape($value) . '</span></span>';

        return $xhtml;
    }

}

?>