<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\User;

class My_View_Helper_ProfileLink extends Zend_View_Helper_Abstract
{
    /**
     * @param User $user
     * @param array $attributes
     * @param array $params
     * @return null
     */
    public function profileLink(User $user = null, $attributes = [], $params = [])
    {
        if (empty($user)) {
            return null;
        }

        $email = '';
        if (isset($attributes['email'])) {
            $email = '<a href="javascript:addMessageDialog(' . $user->getId() . ')"><i class="ui-icon ui-icon-mail-closed"></i></a>';
            unset($attributes['email']);
        }

        if (isset($attributes['value'])) {
            $value = $attributes['value'];
            unset($attributes['value']);
        } else {
            $value = $user->getName();
        }

        if ($user->getName() == 'System') {
            $retVal = $this->view->htmlElement('span', $value, $attributes, $params);
        } else {
            $retVal = $this->view->htmlElement('a', $value, $attributes + [
                    'href' => '/profile/?person=' . $user->getId(),
                ], $params);
        }
        return $retVal . $email;
    }

    /**
     * @param User[] $users
     * @param array $attributes
     * @param array $params
     * @return null
     */
    public function profileLinks($users = [], $attributes = [], $params = [])
    {
        $retVal = [];
        foreach ($users as $user) {
            $retVal[] = $this->profileLink($user, $attributes, $params);
        }
        return implode('<br/>', $retVal);
    }
}

?>