<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition;

class My_View_Helper_ResearchSearchLink extends Zend_View_Helper_Abstract
{

    public function researchSearchLink(Exposition $research, $attribs = [], $params = [])
    {
        if (isset($attribs['value'])) {
            $value = $attribs['value'];
            unset($attribs['value']);
        } else {
            $value = $research->getTitle();
        }

        return $this->view->htmlElement('a', $value, $attribs + [
                    'href'   => $this->view->researchSearchUrl($research),
                    'target' => '_blank',
                ], $params) . ' (' . $research->getDate() . ')';
    }

}

?>