<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_View_Helper_Resource extends Zend_View_Helper_Abstract
{
    public function resource()
    {
        return $this;
    }

    public function getMinifiedCssFile(array $files)
    {
        $basePath = APPLICATION_PATH . '/../public/';
        $minifiedFile = $this->getMinifiedFilename($files, '.css');
        if (!file_exists($basePath . $minifiedFile)) {
            $resourceContent = [];
            foreach ($files as $resource) {
                $resourceContent[] = file_get_contents($basePath . $resource);
            }
            file_put_contents($basePath . $minifiedFile, CssMin::minify(implode(PHP_EOL, $resourceContent)));
        }
        return '/' . $minifiedFile;
    }

    public function getMinifiedJsFile(array $files)
    {
        $basePath = APPLICATION_PATH . '/../public/';
        $minifiedFile = $this->getMinifiedFilename($files, '.js');
        if (!file_exists($basePath . $minifiedFile)) {
            $resourceContent = [];
            foreach ($files as $key => $resource) {
                if ($resource === false) {
                    $resourceContent[] = file_get_contents($basePath . $key);
                } else {
                    $resourceContent[] = \JShrink\Minifier::minify(file_get_contents($basePath . $resource), ['flaggedComments' => false]);
                }
            }
            file_put_contents($basePath . $minifiedFile, implode(PHP_EOL . ';', $resourceContent));
        }
        return '/' . $minifiedFile;
    }

    protected function getMinifiedFilename(array $files, $extension)
    {
        $identifier = '';
        foreach ($files as $filename) {
            $identifier .= filemtime(APPLICATION_PATH . '/../public/' . $filename) . $filename;
        }
        return 'rc/minified/' . md5($identifier) . $extension;
    }
}

?>