<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition;
use Rc\Domain\Model\User;

class My_View_Helper_Seo extends Zend_View_Helper_Abstract
{

    public function seo()
    {
        return $this;
    }

    public function user(User $user)
    {
        return $this->view->jsonLD()->user($user);
    }

    /**
     * @param Exposition $exposition
     * @return string
     */
    public function exposition(Exposition $exposition)
    {
        if (!$exposition->isPublished()) {
            return null;
        }

        return '
            <meta name="citation_title" content="' . $exposition->getTitle() . '"/>
            <meta name="citation_author" content="' . $exposition->getAuthor()->getTitle() . '"/>
            <meta name="citation_publication_date" content="' . $exposition->getPublishedDate() . '"/>
            <meta name="citation_journal_title" content="' . $exposition->getPortal()->getTitle() . '"/>
            <meta name="citation_issue" content="' . $exposition->getPortalEdition() . '"/>
            <link rel="author" href="' . $this->view->url()->profileUrl($exposition->getAuthor()) . '"/>
            ' . $this->view->jsonLD()->exposition($exposition);
    }
}
