<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition\Popover;
use Rc\Domain\Model\Research\Exposition\Weave;

class My_View_Helper_WeaveDecorator extends Zend_View_Helper_Abstract
{

    public function weaveDecorator(Weave $weave, $content)
    {
        $contentAttribs = [
            'id'    => 'content',
            'style' => [
                'border'     => [
                    'width' => (int)$weave->getBorderWidth() . 'px',
                    'style' => $weave->getBorderStyle(),
                    'color' => $weave->getBorderColor(),
                ],
                'background' => [
                    'color' => $weave->getBackgroundColor(),
                ],
            ],
        ];
        $weaveContainerAttribs['id'] = 'container-weave';
        if (!$weave instanceof Popover) {
            $weaveContainerAttribs['style'] = [
                'top'    => (int)$weave->getMarginTop() . 'px',
                'right'  => (int)$weave->getMarginRight() . 'px',
                'bottom' => (int)$weave->getMarginBottom() . 'px',
                'left'   => (int)$weave->getMarginLeft() . 'px',
            ];
        }
        $weaveAttribs = [
            'id'    => 'weave',
            'style' => [
                'width'      => ($weave->getWidth() + $weave->getPaddingLeft() + $weave->getPaddingRight()) . 'px',
                'height'     => ($weave->getHeight() + $weave->getPaddingTop() + $weave->getPaddingBottom()) . 'px',
                'background' => [
                    'image'    => $this->view->wrap($weave->getBackgroundImageUrl(), 'url(', ')', false),
                    'position' => $weave->getBackgroundImagePosition(),
                    'repeat'   => $weave->getBackgroundImageStyle(),
                    'size'     => $weave->getBackgroundImageSize(),
                ],
            ],
        ];
        $params = ['render' => false];

        return $this->view->htmlElement('div', $this->view->htmlElement('div', $this->view->htmlElement('div', $content, $weaveAttribs, $params), $weaveContainerAttribs, $params),
            $contentAttribs, $params);
    }

}

?>