<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Work;

class My_View_Helper_WorkDecorator extends Zend_View_Helper_Abstract
{
    /**
     * @var array
     */
    private $_defaultOptions = [
        'shared' => false,
    ];

    /**
     * @param Work $work
     * @param array $options
     * @return string
     */
    public function forList(Work $work, array $options = [])
    {
        $options += $this->_defaultOptions;

        if ($options['shared']) {
            $shared = '<img style="float:right" src="/rc/images/share.png" title="by ' . $work->getAuthor()->getName() . '"/>';
        } else {
            $shared = null;
        }

        return '<tr 
                    class="work"
                    data-id="' . $work->getId() . '"
                    data-childcount="1"
                >
                    <td class="hitarea mif-plus" style="cursor:pointer"></td>
                    <td>' . $shared . $this->view->escape($work->getTitle()) . '</td>
                </tr>';
    }

}

?>