<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Dotenv\Dotenv;
use Rc\Service\Ingest\MediaTypes;
use Rc\Utility\TokenGenerator;

require_once __DIR__ . '/../../vendor/autoload.php';

$env = new Dotenv(__DIR__ . '/../../');
$env->load();

Zend_Registry::set('Config', [
    'app' => [
        'salt_token' => env('APP_SALT_TOKEN'),
    ],
]);

$path = parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);

if ($path == '/auth/favicon.ico') {
    http_response_code(200);
    return;
}

if (!isset($_GET['t']) || !isset($_GET['e']) || empty($path)) {
    http_response_code(403);
    echo '<h3>Error</h3>Forbidden';
    return;
}

if ($_GET['t'] != TokenGenerator::generate($path . $_GET['e'])) {
    http_response_code(403);
    echo '<h3>Error</h3>Forbidden';
    return;
}

if ($_GET['e'] < time()) {
    http_response_code(410);
    echo '<h3>Error</h3>Gone';
    return;
}

header('X-Accel-Redirect: ' . sendfile('/media' . $path));
header('Content-Type: ' . MediaTypes::getMediaTypeFromFilename($path));
