function TableList() {

    TableList.prototype.draw = function () {
        if (!this.setup) {
            this.initDataTable();
        } else if (this.CONTAINER_TABLE.is(':visible')) {
            this.dataTable().draw();
        }
    };

    TableList.prototype.dataTable = function () {
        this.initDataTable();

        return jQueryNew(this.CONTAINER_TABLE).DataTable();
    };

    TableList.prototype.initDataTable = function () {
        var $this = this;

        if (this.setup) {
            return;
        }

        this.setup = true;

        this.setupDataTable();

        this.CONTAINER_CONTENT.html('<tr><td colspan="' + $('thead th', this.CONTAINER_TABLE).length + '">Loading data...');

        jQueryNew(window).on('resize', function () {
                $this.draw()
            }
        );

        this.CONTAINER_TOOLBAR = $('.t-menu', this.CONTAINER);
        this.CONTAINER_SCROLL = $('.dataTables_scrollBody', this.CONTAINER);

        this._updateButtonState();

        this.load();
    };

    TableList.prototype.eLoad = function (data, status, xhr) {
        var $this = this;

        this.dataTable().clear();

        $(data).filter('tr').each(function () {
            $this.dataTable().row.add(this)
        });

        this.dataTable().draw();

        if (xhr && xhr.getResponseHeader('X-Repository-Auth') === '0') {
            this.CONTAINER_SCROLL.closest('.dataTables_wrapper').html('<p><strong>Authentication failed!</strong><br/>Please review the settings under the + tab.</p>')
        }
    };

    TableList.prototype.removeChildren = function (ids) {
        var $this = this;

        ids = this.listToString(ids);

        this.children(ids).removeClass(this.CLASS_SELECTED).fadeOut(this.EFFECT_DURATION, 'easeInCubic', function () {

            $.each($this.dataTable().rows().nodes(), function () {
                if ($.inArray($(this).attr('data-id'), ids) !== -1) {
                    $this.dataTable().row(this).remove();
                }
            });

            $this._apply('eRemoveChildren', [ids]);

            $this.dataTable().draw();
        });
    };

    TableList.prototype._updateButtonState = function (children) {
        children = children || this.selectedChildren();

        switch (children.length) {
            case 0:
                $('li[data-context!="global"]', this.CONTAINER_TOOLBAR).addClass('disabled');
                break;

            case 1:
                $('li[data-context!="global"]', this.CONTAINER_TOOLBAR).removeClass('disabled');
                break;

            default:
                $('li[data-context="single"]', this.CONTAINER_TOOLBAR).addClass('disabled');
                $('li[data-context!="single"]', this.CONTAINER_TOOLBAR).removeClass('disabled');
        }
    };

    TableList.prototype.init = true;
    TableList.prototype = new List();
    TableList.prototype.constructor = TableList;
}

new TableList();