function ToolList(init) {
    var $this = this;

    this.URL = '/editor/tools?research=' + Editor.getResearchId();
    this.CONTAINER = $('#tools');
    this.CONTAINER_CONTENT = this.CONTAINER;
    this.SELECTOR_CHILD = 'li';

    this.reload = function() {
        $this.CONTAINER_CONTENT.html('<li class="loading"><em>Loading</em>');
        $this.load();
    };

    this.eAfterLoad = function () {
        this.children().each(function () {
            $this.initChild(this);
        });
    };

    this.initChild = function (item) {
        (item = $(item))
            .click(function () {
                Dialog.editToolTemplate(item.data('tool'));
            })
            .disableSelection();

        var snapToGrid = $('#sidebar-commands-snaptogrid');
        var gridSize = $('#sidebar-commands-grid');

        item.addClass('tool-draggable').draggable({
            helper: function () {
                return $('<div id="tool-dragging"></div>').css({
                    width: $(this).attr('data-size-width'),
                    height: $(this).attr('data-size-height')
                });
            },
            drag: function (event, ui) {
                var grid = 1;
                if (snapToGrid.is(':checked')) {
                    grid = Math.max(parseInt(gridSize.val()) / 10, 1);
                    ui.position.left = Math.ceil(ui.position.left / grid) * grid;
                    ui.position.top = Math.ceil(ui.position.top / grid) * grid;
                }

                Editor.ContentList.adjustContainerSize();
            },
            cursorAt: {
                left: 3,
                top: 3
            },
            opacity: 0.7,
            appendTo: Editor.ContentList.CONTAINER_CONTENT
        })
    };

    if (!ToolList.prototype.init) {
        ToolList.prototype = new List(init);
        ToolList.prototype.constructor = ToolList;
    }
}
new ToolList();