function UploadList(init) {
    const $this = this;

    let dialogs = {};

    this.CONTAINER = $('#_uploads');
    this.CONTAINER_CONTENT = $('tbody', this.CONTAINER);
    this.CONTAINER_TABLE = $('.table', this.CONTAINER);
    this.CONTAINER_SCROLL = $('.dataTables_scrollBody', this.CONTAINER);
    this.CONTAINER_TOOLBAR = $('.t-menu', this.CONTAINER);
    this.CONTAINER_LOADING = $('.container-loading', this.CONTAINER);
    this.SELECTOR_CHILD = 'tr';
    this.LINK_UPLOADS = $('[href="#_uploads"]').parent();

    this.showDialog = function (id) {
        dialogs[id]._eForeground();
    };

    this.load = function () {
        List.prototype._eLoad.call(this, '');
    };

    this.loadChild = function (id, options) {
        this.LINK_UPLOADS.show();

        const dialog = $('#' + id),
            name = $('[name*="name"]:visible', dialog).val();

        let label = $('#ui-dialog-title-dialog', dialog).html();
        if (name) {
            label += ' - ' + name;
        }

        if (this.child(id).length === 0) {
            this.dataTable().row.add($('<tr data-id="' + id + '"><td>' + label + '</td></tr>').get(0)).draw();

            dialogs[id] = options.dialogForm;
        }

        List.prototype._eLoadChild.call(this, this.child(id));
    };

    this.setupDataTable = function () {
        jQueryNew(this.CONTAINER_TABLE).DataTable({
            columnDefs: [
                {
                    orderable: true
                }
            ],
            columns: [
                {type: 'string'}
            ],
            fixedColumns: true,
            bAutoWidth: false,
            preDrawCallback: function () {
                const parent = $this.CONTAINER_TABLE.parent();

                parent.css('height', $(window).height() - $this.CONTAINER_TABLE.offset().top - 15);
            },
            scrollY: $(window).height() - this.CONTAINER_TABLE.offset().top - 15,
            searching: true,
            paging: false,
            stateSave: false,
            info: false,
            classes: {
                sSortAsc: 'sort-asc sortable-column',
                sSortDesc: 'sort-desc sortable-column',
                sSortable: 'sortable-column',
                sFilterInput: 'border-left-none border-top-none border-bottom-none'
            },
            oLanguage: {
                sSearch: '' +
                '   <div class="border bd-default" style="margin-bottom:10px; overflow:hidden; width:357px">\n' +
                '        <ul class="t-menu horizontal open compact">\n' +
                '            <li data-context="global" style="width:316px">_INPUT_</li>\n' +
                '            <li data-context="single"><a href="#" onclick="Editor.UploadList.showDialog(Editor.UploadList.selectedChildId());return false"><span class="icon mif-eye"></span></a></li>\n' +
                '        </ul>\n' +
                '    </div>',
                sSearchPlaceholder: 'Search...'
            }
        }).on('draw', function () {
            $this._updateButtonState();
        });
    };

    this.eAfterLoad = function () {
        this.children().each(function () {
            $this.initChild(this);
        });
    };

    this.eAfterLoadChild = function (data) {
        this.initChild(data);

        this.dataTable().draw();
    };

    this.eAfterSelectChild = function (id, options) {
        this._updateButtonState();
    };

    this.eAfterToggleChildSelection = function () {
        this._updateButtonState();
    };

    this.eRemoveChildren = function (ids) {
        this._updateButtonState();

        $.each(ids, function(i, value) {
            delete(dialogs[value]);
        });
    };

    this.initChild = function (item) {
        (item = $(item))
            .click(function (event) {
                const selectedChildren = $this.selectedChildren();

                if (event.ctrlKey || event.metaKey || (selectedChildren.length === 1 && selectedChildren.is(item))) {
                    $this.toggleChildSelection(item.data('id'));
                } else {
                    $this.selectChild(item.data('id'));
                }
            })
            .dblclick(function (event) {
                $this.showDialog($(item).data('id'));
            })
            .disableSelection();
    };

    if (!UploadList.prototype.init) {
        UploadList.prototype = new TableList(init);
        UploadList.prototype.constructor = UploadList;
    }
}

new UploadList();