var NavigationPicture, selectedComment, showMissingFontsHint = true;
var autoStartItems = [];

$(function () {
    jwplayer.key = "SeIeABotC08750h3V7r77b550BnnaXah0rvcdaFiL6U=";

    WEAVE = $('#weave');
    CONTAINER_SCROLL = $('#container-weave').scroll(generateCitationForCurrentAspect);
    initBrowserAndOsDetection();
    initPosition();
    initNavigation();
    initNavigationTooltip();
    initAutoplayTooltip();
    initLightBox();
    initHoverPopup();
    initSlideShow();
    initAspectRatio();
    initFootNotes();
    initFollowLinkOnClick();
    initAudios();
    initVideos();
    initPlayTool();
    initComments();
    initObjectViewer();
    adjustResearchTitle();
    generateCitationForCurrentAspect();
    convertLinksPointingToCurrentWeave();
    detectZoomLevel();
    lazyLoadImages();
    initPopovers();
    detectMissingFonts();
    trackVisitDuration();

    if (navigator.appVersion.indexOf('10_7') != -1) { // force scrollbar for lion
        $('.scrollbar-always').addClass('lion');
    }

    if (!Editor.getSettings().textchanges) {
        $('#content').toggleClass('hide-text-changes');
    }

    navigationPicture = new NavigationPicture(true);
});

function initNavigationTooltip() {
    var button = $('#navigation-tooltip').find('button');
    button.button();
    button.click(function () {
        $.cookie('navigationtooltip', 1, {path: '/'});
        $('#navigation-tooltip').remove();

        $.post('/view/hide-navigation-tooltip');
    });
}

function initAutoplayTooltip() {
    var $autoplayTooltip = $('#autostart-tooltip');

    $autoplayTooltip.find('a').click(function() {
        $.each(autoStartItems, function() {
            this.play(true);
        });

        autoStartItems = [];

        $autoplayTooltip.hide();
        return false;
    });

    var button = $autoplayTooltip.find('button');
    button.button();
    button.click(function () {
        autoStartItems = [];

        $autoplayTooltip.hide();
        return false;
    });
}

function initBrowserAndOsDetection() {
    var pgwBrowser = jQuery.pgwBrowser();
    $('#content').addClass('browser-' + pgwBrowser.browser.group.toLowerCase()).addClass('os-' + pgwBrowser.os.group.replace(' ', '').toLowerCase());
}

function adjustResearchTitle() {
    if ($(document).width() < 1000) {
        var html = $('span.menu-metadata').html() || '';
        $('span.menu-metadata').html(html.substr(0, 40) + (html.length > 40 ? ' ...' : ''));
    }
}

function initPosition() {
    $('[data-position]').each(function () {
        initPositionOf(this);
    });
}

function initPositionOf(element) {
    var $element = $(element);
    var rotatedParent = $element.closest('[style*=rotate]');
    var tmpTransform = (rotatedParent.css('transform') || rotatedParent.css('-moz-transform') || rotatedParent.css('-webkit-transform') || rotatedParent.css('-o-transform') || rotatedParent.css('-ms-transform'));
    rotatedParent.css({
        '-moz-transform': 'rotate(0deg)',
        '-o-transform': 'rotate(0deg)',
        '-webkit-transform': 'rotate(0deg)',
        '-ms-transform': 'rotate(0deg)',
        'transform': 'rotate(0deg)'
    });

    var options = $.parseJSON($element.attr('data-position'));
    $element.position({
        at: options.at,
        my: options.my,
        of: options.of || $element.parent(),
        collision: options.collision
    });

    rotatedParent.css({
        '-moz-transform': tmpTransform,
        '-o-transform': tmpTransform,
        '-webkit-transform': tmpTransform,
        '-ms-transform': tmpTransform,
        'transform': tmpTransform
    });
}

function initFootNotes() {
    $('.footnote').each(function (i, obj) {
        $(obj).boxy({
            modal: true
        });
    });
}

function convertLinksPointingToCurrentWeave() {
    var currentLocation = location.pathname.split('/').slice(0, 4).join('/');
    $('a[href*="' + currentLocation + '"]').click(function () {
        if (getWeaveId() === getWeaveId(this.pathname)) {
            CONTAINER_SCROLL.stop().scrollTo({
                left: getWeavePosition(this.pathname).x || $('body').attr('data-x'),
                top: getWeavePosition(this.pathname).y || $('body').attr('data-y')
            });
            return false;
        }
    });
    $('a[href*=".html"]').click(function () {
        CONTAINER_SCROLL.stop().scrollTo({
            left: getWeavePosition(this.search).x,
            top: getWeavePosition(this.search).y
        });
    });
}

function initAspectRatio() {
    if (location.hash === '#note') {
        location.hash = '';
        nextComment();
    } else {
        CONTAINER_SCROLL.scrollLeft(getWeavePosition().x || $('body').attr('data-x'));
        CONTAINER_SCROLL.scrollTop(getWeavePosition().y || $('body').attr('data-y'));
    }
}

function generateCitationForCurrentAspect() {
    var attr = $('#citation').attr('data-citation') || '';
    $('#citation').html(attr.replace(/\$aspect/g, '/' + (CONTAINER_SCROLL.scrollLeft() || 0) + '/' + (CONTAINER_SCROLL.scrollTop() || 0)));
}

function initNavigation() {
    var $mainmenu = $('.mainmenu');

    $('li.menu').hoverIntent({
        timeout: 200,
        over: function () {
            $(this).addClass('hovering');
            navigationPicture.updateContentAspect();
            navigationPicture.updateCurrentAspect();
        },
        out: function () {
            $(this).removeClass('hovering');
        }
    });

    $('#navigation').hoverIntent({
        timeout: 6000,
        over: function () {
            if (hideNavigationTimeout) {
                clearTimeout(hideNavigationTimeout);
                hideNavigationTimeout = false;
            }
            $mainmenu.fadeIn(0);
        },
        out: function () {
            if (!$mainmenu.data('display-permanently')) {
                $mainmenu.fadeOut('fast');
            }
        }
    });

    hideNavigationTimeout = setTimeout(function () {
        if (!$mainmenu.data('display-permanently')) {
            $mainmenu.fadeOut('fast');
        }
    }, 5000);
}

function initLightBox() {
    var imgs = $('.tool-picture[href]');
    for (var i = 0; i < imgs.length; i++) {
        $(imgs[i]).lightBox({
            imageLoading: '/rc/images/lightbox/lightbox-ico-loading.gif',
            imageBtnClose: '/rc/images/lightbox/lightbox-btn-close.gif',
            imageBtnPrev: '/rc/images/lightbox/lightbox-btn-prev.gif',
            imageBtnNext: '/rc/images/lightbox/lightbox-btn-next.gif'
        });
    }
}

function initFollowLinkOnClick() {
    var currentLocation = location.pathname.split('/').slice(0, 4).join('/');
    $('div[data-follow-link]').click(function () {
        if ($(this).attr('data-follow-link').indexOf(currentLocation) != -1 && getWeaveId() == getWeaveId($(this).attr('data-follow-link'))) {
            CONTAINER_SCROLL.stop().scrollTo({
                left: getWeavePosition($(this).attr('data-follow-link')).x || $('body').attr('data-x'),
                top: getWeavePosition($(this).attr('data-follow-link')).y || $('body').attr('data-y')
            });
        } else {
            location.href = $(this).attr('data-follow-link');
        }
        return false;
    });
}

function initSlideShow() {
    var audioPlayerCounter = [];
    var prevAudioPlayer = [];
    var currentAudioPlayer = [];
    var nextAudioPlayer = [];
    var autoplayTimeout;

    var initLightBox = function (slideshow) {
        slideshow.find('li[href]').lightBox({
            imageLoading: '/rc/images/lightbox/lightbox-ico-loading.gif',
            imageBtnClose: '/rc/images/lightbox/lightbox-btn-close.gif',
            imageBtnPrev: '/rc/images/lightbox/lightbox-btn-prev.gif',
            imageBtnNext: '/rc/images/lightbox/lightbox-btn-next.gif'
        });
    };
    var generateAudioPlayerId = function (slideshow) {
        return 'audio-slide-' + slideshow.attr('data-id') + '-' + (++audioPlayerCounter[slideshow.attr('data-id')]);
    };
    var initAudioPlayer = function (slide, options) {
        var options = options || {};
        var file = $(slide).attr('data-audio');
        if (!file) {
            return false;
        }

        var slideshow = slide.closest('.tool-slideshow');
        var id = generateAudioPlayerId(slideshow);
        var autostart = false;
        if (typeof options.autostart === 'undefined') {
            autostart = true;
        } else if (typeof options.prebuffer === 'undefined') {
            autostart = options.autostart;
        } else {
            autostart = options.autostart || options.prebuffer;
        }

        $('<div></div>').attr('id', id).prependTo($(slideshow));

        mediaPlayerStopCallbacks[id] = function () {
            jwplayer(id).stop();
        };

        return jwplayer(id).setup({
            file: file,
            height: 0,
            width: 0,
            icons: false,
            volume: (typeof options.volume === 'undefined' ? 100 : options.volume),
            autostart: autostart,
            bufferlength: 0,
            events: {
                volume: function (event) {
                    if (!event.volume) {
                        this.stop();
                    }
                },
                ready: function () {
                    if ($(this).attr('data-remove')) {
                        this.remove();
                        $('#' + id).remove();
                    }
                },
                complete: function () {
                    var player = this;
                    $('.slideshow-nav .slideshow-replay', $('#' + this.id).closest('.tool')).fadeIn().click(function () {
                        player.seek(0).play(true);
                    });
                },
                play: function () {
                    $('.slideshow-nav .slideshow-replay', $('#' + this.id).closest('.tool')).fadeOut();

                    collectMetric('jwplayer.play', 1, {type: 'slideshow', context: 'view'});

                    disableLoopAfterTooManyIterations(jwplayer(id));
                },
                autostartNotAllowed: function() {
                    autostartNotAllowed(this);
                },
                beforePlay: function() {
                    if (this.getMute()) {
                        this.setMute(false);
                        autostartNotAllowed(this);
                    } else if (!options.autostart && options.prebuffer) { // prebuffer only
                        jwplayer(id).stop();
                        delete (options.prebuffer);
                    }
                }
            }
        }).setVolume(typeof options.volume === 'undefined' ? 100 : options.volume);
    };
    var removeAudioPlayer = function (audioPlayer) {
        if (audioPlayer && audioPlayer.getVolume() <= 0.1) {
            audioPlayer.remove();
            $('#' + audioPlayer.id).remove();
        } else if ($(audioPlayer).length > 0) {
            $(audioPlayer).attr('data-remove', 1);
        }
    };
    var crossfade = function (slideshow, currentSlide, direction) {
        var index = slideshow.attr('data-id');

        var stepSize = 100;
        if (parseInt(slideshow.data('options').crossfade) !== 0) {
            stepSize = 100 / (parseInt(slideshow.data('options').crossfade) * 1000 / 25);
        }
        var stepIndex = stepSize;

        var playerToTurnUp;
        var playerToTurnDown = currentAudioPlayer[index];

        if (direction === 'next') {
            removeAudioPlayer(prevAudioPlayer[index]);
            playerToTurnUp = nextAudioPlayer[index];
        } else if (direction === 'prev') {
            removeAudioPlayer(nextAudioPlayer[index]);
            playerToTurnUp = prevAudioPlayer[index];
        } else {
            return false;
        }

        if (playerToTurnUp) {
            jwplayer(playerToTurnUp.id).seek(0).play(true);
        }

        var interval = setInterval(function () {
            if (playerToTurnDown) {
                jwplayer(playerToTurnDown.id).setVolume(Math.max(100 * Math.round(Math.cos(stepIndex / 100 * Math.PI / 2) * 1e6) / 1e6, 0));
            }
            if (playerToTurnUp) {
                jwplayer(playerToTurnUp.id).setVolume(Math.min(100 * Math.round(Math.sin(stepIndex / 100 * Math.PI / 2) * 1e6) / 1e6, 100));
            }

            stepIndex += stepSize;
            if (stepIndex > 100) {
                clearInterval(interval);
            }
        }, 25);

        if (direction === 'next') {
            prevAudioPlayer[index] = initAudioPlayer(currentSlide, {
                volume: 0.1,
                autostart: false,
                prebuffer: true
            });
            currentAudioPlayer[index] = nextAudioPlayer[index];
            if (currentSlide.next().length == 0 && slideshow.data('options').loop) {
                nextAudioPlayer[index] = initAudioPlayer($('li', slideshow).first().next(), {
                    volume: 0.1,
                    autostart: false,
                    prebuffer: true
                });
            } else if (currentSlide.next().next().length == 0 && slideshow.data('options').loop) {
                nextAudioPlayer[index] = initAudioPlayer($('li', slideshow).first(), {
                    volume: 0.1,
                    autostart: false,
                    prebuffer: true
                });
            } else {
                nextAudioPlayer[index] = initAudioPlayer(currentSlide.next().next(), {
                    volume: 0.1,
                    autostart: false,
                    prebuffer: true
                });
            }
        } else if (direction == 'prev') {
            nextAudioPlayer[index] = initAudioPlayer(currentSlide, {
                olume: 0.1,
                autostart: false,
                prebuffer: true
            });
            currentAudioPlayer[index] = prevAudioPlayer[index];
            if (currentSlide.prev().length == 0 && slideshow.data('options').loop) {
                prevAudioPlayer[index] = initAudioPlayer($('li', slideshow).last().prev(), {
                    volume: 0.1,
                    autostart: false,
                    prebuffer: true
                });
            } else if (currentSlide.prev().prev().length == 0 && slideshow.data('options').loop) {
                prevAudioPlayer[index] = initAudioPlayer($('li', slideshow).last(), {
                    volume: 0.1,
                    autostart: false,
                    prebuffer: true
                });
            } else {
                prevAudioPlayer[index] = initAudioPlayer(currentSlide.prev().prev(), {
                    volume: 0.1,
                    autostart: false,
                    prebuffer: true
                });
            }
        }
    };
    var slideshows = $('.tool-slideshow');
    var audioPlayer = [];
    for (var i = 0; i < slideshows.length; i++) {
        var slideshow = $(slideshows[i]);
        var firstSlide = $('li', slideshow).first();

        initLightBox(slideshow);

        audioPlayerCounter[slideshow.attr('data-id')] = 0;
        prevAudioPlayer[slideshow.attr('data-id')] = initAudioPlayer($('li', slideshow).last(), {
            volume: 0.1,
            autostart: false,
            prebuffer: true
        });
        currentAudioPlayer[slideshow.attr('data-id')] = initAudioPlayer(firstSlide);
        nextAudioPlayer[slideshow.attr('data-id')] = initAudioPlayer(firstSlide.next(), {
            volume: 0.1,
            autostart: false,
            prebuffer: true
        });

        $('li', slideshow).hide().first().show();
        slideshow.data('options', $.parseJSON(slideshow.attr('data-options')));

        var prev = $('<img/>').attr('src', '/rc/images/slideshow/prev.png').addClass('slideshow-prev').click((function (slideshow) {
            return function () {
                prevFunction(slideshow);
                stopAutoplay();
                hideHover();
            }
        })(slideshow));
        var next = $('<img/>').attr('src', '/rc/images/slideshow/next.png').addClass('slideshow-next').click((function (slideshow) {
            return function () {
                nextFunction(slideshow);
                stopAutoplay();
                hideHover();
            }
        })(slideshow));
        var replay = $('<img/>').attr('src', '/rc/images/slideshow/replay.png').addClass('slideshow-replay').css('display', 'none');
        slideshow.append($('<div/>').addClass('slideshow-nav').append(prev).append(replay).append(next)).css('padding-bottom', parseInt(slideshow.css('padding-bottom')) + 23);

        if (!slideshow.data('options').loop || $('li', slideshow).length <= 1) {
            prev.hide();
        }
        if ($('li', slideshow).length <= 1) {
            next.hide();
        }
        $('.slideshow-nav', slideshow).click((function (slideshow) {
            return function () {
                var navBar = $(this);
                if ($('li[data-audio]:first', navBar.closest('.tool')).length > 0) {
                    navBar.attr('data-disabled', 'true').fadeOut(parseInt(slideshow.data('options').fade), function () {
                        setTimeout(function () {
                            navBar.fadeIn(parseInt(slideshow.data('options').fade), function () {
                                navBar.removeAttr('data-disabled')
                            });
                        }, slideshow.data('options').timeout);
                    });
                }
            };
        })(slideshow)).toggle(slideshow.data('options').shownavbar == 1);

        var defaultSpeed = slideshow.data('options').defaultspeed,
            speedPerSlide = slideshow.data('options').speedperslide;

        if ((defaultSpeed || !$.isEmptyObject(speedPerSlide)) && slideshow.data('options').autoplay !== '' && slideshow.data('options').autoplay !== 'no') {
            (function (slideshow, speedPerSlide, defaultSpeed) {
                return $('ul', slideshow).css('cursor', 'pointer').bind('click', function () {
                    if (autoplayTimeout) {
                        stopAutoplay();
                        return;
                    }
                    var next = $('.slideshow-next', slideshow);
                    if (next.css('display') !== 'none') {
                        nextFunction(slideshow);
                    }
                    startAutoplay(slideshow, speedPerSlide, defaultSpeed);
                });
            })(slideshow, speedPerSlide, defaultSpeed);

            (function (slideshow, speedPerSlide, defaultSpeed) {
                var interval = setInterval(function () {
                    if (slideshow.hasClass('tool-is-loading')) {
                        return;
                    }
                    if (slideshow.data('options').autoplay === 'auto') {
                        startAutoplay(slideshow, speedPerSlide, defaultSpeed);
                    }
                    clearInterval(interval);
                });
            })(slideshow, speedPerSlide, defaultSpeed);
        }
    }


    function nextFunction(slideshow) {
        var nextButton = $('.slideshow-next', slideshow);
        if (nextButton.parent().attr('data-disabled')) {
            return false;
        }
        var current = $('li:visible', slideshow);
        current.hide();
        crossfade(slideshow, current, 'next');
        if (slideshow.data('options').loop) {
            if (current.next().length == 0) {
                $('li:first', slideshow).show();
            } else {
                current.next().show();
            }
        } else {
            current.next().show();
            if ($('li', slideshow).index(current.next()) == $('li', slideshow).length - 1) {
                nextButton.hide();
            }
            $('.slideshow-prev', slideshow).show();
        }
    }

    function prevFunction(slideshow) {
        var prevButton = $('.slideshow-prev', slideshow);
        if (prevButton.parent().attr('data-disabled')) {
            return false;
        }
        var current = $('li:visible', slideshow);
        current.hide();
        crossfade(slideshow, current, 'prev');
        if (slideshow.data('options').loop) {
            if (current.prev().length == 0) {
                $('li:last', slideshow).show();
            } else {
                current.prev().show();
            }
        } else {
            current.prev().show();
            if ($('li', slideshow).index(current.prev()) == 0) {
                prevButton.hide();
            }
            $('.slideshow-next', slideshow).show();
        }
    }

    function startAutoplay(slideshow, speedPerSlide, defaultSpeed) {
        autoplayTimeout = setTimeout(function () {
            nextFunction(slideshow);
            if ($('.slideshow-next', slideshow).css('display') !== 'none') {
                startAutoplay(slideshow, speedPerSlide, defaultSpeed);
            }
        }, (speedPerSlide[$('li:visible', slideshow).data('id')] || defaultSpeed) * 1000);
    }

    function stopAutoplay() {
        if (!autoplayTimeout) {
            return;
        }
        clearTimeout(autoplayTimeout);
        autoplayTimeout = null;
    }

    function hideHover() {
        $('#hover').remove();
    }
}

function initObjectViewer() {
    $('.tool-objectviewer').click(function () {
        var tool = $(this);
        if (tool.css('cursor') == 'move') {
            return;
        }

        var objectViewer = new ObjectViewer(tool.find('img'), {
            levels: tool.attr('data-levels'),
            startimage: tool.attr('data-start-image'),
            rotomatic: tool.attr('data-auto-rotate') == '1' ? 80 : 0,
            images: tool.attr('data-resources').split(',')
        });

        $(document)
            .bind('mousedown.objectviewer', function (event) {
                if ($(event.target).closest('.tool').attr('data-id') == tool.attr('data-id')) {
                    return;
                }

                objectViewer.unload();
                delete (objectViewer);
                tool.css('cursor', 'pointer');
            })
            .bind('keyup.objectviewer', function (event) {
                if (event.keyCode != 27) {
                    return;
                }

                objectViewer.unload();
                delete (objectViewer);
                tool.css('cursor', 'pointer');
            });

        tool.css('cursor', 'move');
    });
}

function getWeaveId(link) {
    if (!link) {
        return $('body').data('weave') + '';
    }
    var value = link.replace(/http:\/\//, '').replace(/https:\/\//, '');
    return value.split('/')[3];
}

function getApplicationId() {
    var query = url('?') || {};
    return query.application || '';
}

function getResearchId(link) {
    if (!link) {
        return $('body').data('research');
    }
    return link.replace(/http:\/\//, '').replace(/https:\/\//, '').split('/')[2];
}

function getWeavePosition(link) {
    var pieces = (link || location.pathname).replace(/http:\/\//, '').replace(/https:\/\//, '').split('/');
    if (pieces.length >= 5) {
        return {
            x: pieces[4],
            y: pieces[5] || 0
        }
    }

    pieces = (link || location.search).match(/.*x=([0-9]+).*y=([0-9]+).*/i) || [];
    return {
        x: pieces[1] || 0,
        y: pieces[2] || 0
    }
}

function NavigationPicture(init) {
    var $this = this;

    this.CONTAINER_CONTENT = $('div.menu-navigation');
    this.CURRENT_ASPECT = $('#aspect-current', this.CONTAINER_CONTENT);
    this.CONTENT = $('img', this.CONTAINER_CONTENT);
    this.CLASS_CHILD_DRAGGING = 'child-dragging';
    this.WEAVE_CONTAINER = $('#container-weave');
    this.WEAVE_CONTENT = $('#weave');
    this.params = {};

    this.init = function () {
        reloadNavigationOverview();
        $this.CONTAINER_CONTENT.mousedown(function (event) {
            var factor = _getFactor();
            if ($(event.target).attr('id') != $this.CONTAINER_CONTENT.attr('id')) {
                event.layerX += $(event.target).position().left;
                event.layerY += $(event.target).position().top;
            }
            _scrollTo(Math.max(0, event.layerX - $this.CURRENT_ASPECT.innerWidth() / 2) / factor.width, Math.max(0, event.layerY - $this.CURRENT_ASPECT.innerHeight() / 2) / factor.height);
            $this.updateCurrentAspect();
        }).click(function () {
            return false;
        }).disableSelection();

        $this.CURRENT_ASPECT.draggable({
            containment: 'parent',
            start: function () {
                $this.CONTAINER_CONTENT.addClass($this.CLASS_CHILD_DRAGGING);
            },
            drag: function () {
                var factor = _getFactor();
                _scrollTo($this.CURRENT_ASPECT.position().left / factor.width, $this.CURRENT_ASPECT.position().top / factor.height);
            },
            stop: function () {
                $this.CONTAINER_CONTENT.removeClass($this.CLASS_CHILD_DRAGGING);
            }
        });
    };

    this.updateCurrentAspect = function () {
        if ($this.CURRENT_ASPECT.hasClass('ui-draggable-dragging')) {
            return;
        }
        $this.updateParams();
        var factor = _getFactor();
        $this.CURRENT_ASPECT.css({
            left: Math.max(0, Math.min($this.CONTENT.width() - factor.width * $this.params.width - 2, factor.width * $this.params.left)),
            top: Math.max(0, Math.min($this.CONTENT.height() - factor.height * $this.params.height + 2, factor.height * $this.params.top)),
            width: factor.width * $this.params.width,
            height: factor.height * $this.params.height
        });
    };

    this.updateContentAspect = function () {
        $this.updateParams();
        $this.CONTENT.css('margin-right', Math.max(0, $this.params.width * _getFactor().width - $this.CONTENT.width()));
        $this.CONTENT.css('margin-bottom', Math.max(0, $this.params.height * _getFactor().height - $this.CONTENT.height()));
    };

    this.updateParams = function () {
        $this.params = {
            left: $this.WEAVE_CONTAINER.scrollLeft(),
            top: $this.WEAVE_CONTAINER.scrollTop(),
            width: $this.WEAVE_CONTAINER.width(),
            height: $this.WEAVE_CONTAINER.height(),
            maxWidth: $this.WEAVE_CONTENT.width(),
            maxHeight: $this.WEAVE_CONTENT.height()
        };
    };

    var _getFactor = function () {
        return {
            width: $this.CONTENT.innerWidth() / $this.params.maxWidth,
            height: $this.CONTENT.innerHeight() / $this.params.maxHeight
        }
    };

    var _scrollTo = function (x, y) {
        $this.WEAVE_CONTAINER.scrollLeft(x).scrollTop(y);
    };

    if (init) {
        this.init();
    }
}

function initHoverPopup() {
    $('.tool').each(function () {
        var text = [];
        if ($(this).data('plaintext')) {
            text.push('<pre>' + $(this).data('plaintext') + '</pre>');
        }
        if (text.length == 0 && !$(this).data('copyright')) {
            return;
        }

        $(this).bind('mousemove', function (event) {
            var hover = text.slice(), copyright = false;
            if ($(this).hasClass('tool-slideshow')) {
                copyright = $('[data-copyright]:visible', this).data('copyright');
            } else {
                copyright = $(this).data('copyright');
            }

            if (copyright) {
                hover.push((text.length ? 'copyright: ' : '') + copyright);
            }

            if ($('#hover').length == 0) {
                $('<div id="hover"></div>').appendTo('#weave');
            }

            $('#hover').css({
                left: event.clientX + CONTAINER_SCROLL.scrollLeft(),
                top: event.clientY + CONTAINER_SCROLL.scrollTop()
            }).html(hover.join('<hr/>'));
        }).bind('mouseout', function () {
            $('#hover').remove();
        })
    });
}

function initAudios() {
    var isIPad = navigator.userAgent.match(/iPad/i);
    $('.tool-audio[data-id]').each(function () {
        var tool = $(this);
        var id = $(this).data('id') + '';
        var audio = $('#audio-' + id, this);
        if (!audio.length) {
            return true;
        }

        var skinName = 'default';
        if (audio.data('display-minimal')) {
            skinName = 'minimal';
        } else if (audio.data('display-volume')) {
            skinName = 'volume';
        }

        if (isIPad) {
            tool.height(Math.max(42, parseInt(tool.height())));
        } else {
            tool.css('height', Math.min(24, parseInt(tool.height())));
        }

        if (audio.data('hide-player')) {
            tool.hide();
        } else {
            $('<div></div>').css('height', isIPad ? 42 : 24).addClass('tool-loading-animation').prependTo(tool)
        }

        jwplayer('audio-' + id).setup({
            file: audio.data('file'),
            image: '/rc/images/tool/audio_play_ipad.jpg',
            width: tool.width(),
            height: isIPad ? 42 : 24,
            repeat: audio.data('loop') ? true : false,
            autostart: audio.data('autoplay') ? true : false,
            volume: 100,
            skin: {name: skinName},
            primary: "html5",
            events: {
                play: function () {
                    $('.tool-loading-animation', tool).remove();
                    mediaPlayers[id] = true;
                    jwplayer($(this).attr('id')).setVolume(100);

                    if (audio.data('stop-other-players')) {
                        pausePlayersExceptOfThis(id);
                    }

                    collectMetric('jwplayer.play', 1, {type: 'audio', context: 'view'});

                    disableLoopAfterTooManyIterations(jwplayer('audio-' + id));
                },
                pause: function () {
                    mediaPlayers[id] = false;
                },
                complete: function () {
                    mediaPlayers[id] = false;
                },
                ready: function () {
                    setTimeout(function () {
                        $('.tool-loading-animation', tool).remove();
                    }, 1000);
                },
                autostartNotAllowed: function() {
                    autostartNotAllowed(this);
                },
                beforePlay: function() {
                    if (this.getMute()) {
                        this.setMute(false);
                        autostartNotAllowed(this);
                    }
                }
            }
        }).setVolume(100);

        mediaPlayerStopCallbacks[id] = function () {
            jwplayer('audio-' + id).stop();
        };
    });
}

function initVideos() {
    $('.tool-video[data-id]').each(function () {
        var tool = $(this);
        var id = tool.data('id') + '';
        var video = $('#video-' + id, this);

        if (!video.length) {
            return true;
        }

        var skinName = 'default';
        if (video.data('hide-player')) {
            skinName = 'none';
        } else if (video.data('display-minimal')) {
            skinName = 'minimal';
        } else if (video.data('display-volume')) {
            skinName = 'volume';
        }

        var defaultStyle = tool.attr('style');

        $('<img class="video-poster" src="' + video.attr('data-image') + '"/>')
            .css({
                width: video.attr('data-image-width'),
                height: video.attr('data-image-height'),
                'margin-top': -video.attr('data-image-height') / 2,
                'margin-left': -video.attr('data-image-width') / 2
            })
            .prependTo(tool);

        var init = false,
            containerLoading = $('<div class="container-loading" style="position:absolute"></div>').hide().insertBefore('#video-' + id);

        tool.bind('click', function () {
            var fullscreenPosition;

            if (init) {
                return;
            }
            init = true;
            containerLoading.show();
            jwplayer('video-' + id).setup({
                image: video.data('image'),
                file: video.data('file'),
                width: $(this).width(),
                height: $(this).height(),
                repeat: video.data('loop') ? true : false,
                autostart: true,
                volume: 100,
                timeSliderAbove: false,
                controls: true,
                skin: {name: skinName},
                primary: "html5",
                stretching: "uniform",
                events: {
                    displayClick: function () {
                        if (video.data('hide-player')) {
                            jwplayer($(this).attr('id')).play(); // toggle play state
                        }
                    },
                    ready: function () {
                        $('#video-' + id).hide();
                        $("#video-" + id + "_jwplayer_display_image").css({
                            width: video.attr('data-image-width'),
                            height: video.attr('data-image-height'),
                            left: '50%',
                            top: '50%',
                            'margin-top': -video.attr('data-image-height') / 2,
                            'margin-left': -video.attr('data-image-width') / 2
                        });

                        containerLoading.hide();
                    },
                    play: function () {
                        containerLoading.hide();
                        $('#video-' + id).show();
                        if (!jwplayer($(this).attr('id')).getMute()) {
                            jwplayer($(this).attr('id')).setVolume(100);
                        }
                        $("div[data-id=" + id + "] .icon").hide();
                        mediaPlayers[id] = true;

                        if (video.data('stop-other-players')) {
                            pausePlayersExceptOfThis(id);
                        }

                        collectMetric('jwplayer.play', 1, {type: 'video', context: 'view'});

                        disableLoopAfterTooManyIterations(jwplayer("video-" + id));
                    },
                    pause: function () {
                        $("div[data-id=" + id + "] .icon").show();
                        mediaPlayers[id] = false;
                    },
                    complete: function () {
                        tool.attr('style', defaultStyle);
                        tool.find("div[data-id=" + id + "] .icon").show();

                        mediaPlayers[id] = false;
                        if (fullscreenPosition) {
                            setTimeout(function () {
                                CONTAINER_SCROLL.scrollLeft(fullscreenPosition.left);
                                CONTAINER_SCROLL.scrollTop(fullscreenPosition.top);
                            }, 500);
                            delete (fullscreenPosition);
                        }
                    },
                    fullscreen: function (event) {
                        if (event.fullscreen) {
                            fullscreenPosition = {
                                left: CONTAINER_SCROLL.scrollLeft(),
                                top: CONTAINER_SCROLL.scrollTop()
                            };

                            tool.attr('style', defaultStyle + ';position: static !important');
                            this.play(true);
                        } else {
                            setTimeout(function () {
                                CONTAINER_SCROLL.scrollLeft(fullscreenPosition.left);
                                CONTAINER_SCROLL.scrollTop(fullscreenPosition.top);
                                delete (fullscreenPosition);
                            }, 250);

                            tool.attr('style', defaultStyle);
                        }
                    },
                    autostartNotAllowed: function () {
                        init = false;
                        autostartNotAllowed(this);
                    },
                    beforePlay: function() {
                        if (this.getMute()) {
                            init = false;
                            this.setMute(false);
                            autostartNotAllowed(this);
                        }
                    }
                }
            }).setVolume(100);

            mediaPlayerStopCallbacks[id] = function () {
                jwplayer('video-' + id).stop();
            };
        });
        if (video.data('autoplay')) {
            tool.trigger('click');
        }
    });
}

function lazyLoadImages() {
    $('.tool', '#weave').each(function () {
        var images = $('img', this);
        if (images.length === 0) {
            return;
        }

        var loadingAnimation = $('<div></div>').addClass('tool-loading-animation').prependTo(this),
            loadedImages = 0,
            tool = $(this).addClass('tool-is-loading');
        images.one('load', function () {
            if (++loadedImages === images.length) {
                loadingAnimation.remove();
                tool.removeClass('tool-is-loading');
            }
        }).each(function () {
            if (this.complete) $(this).load();
        });
    });
}

function initPopovers() {
    $('[data-popover][data-popover!=""]').each(function () {
        var element = $(this),
            popoverId = element.data('popover'),
            options = $.extend({
                top: element.offset().top + CONTAINER_SCROLL.scrollTop(),
                left: element.offset().left + CONTAINER_SCROLL.scrollLeft()
            }, element.data('popover-options')),
            hidePopoverCallback = hidePopover;

        if (options.viewon == 1) {
            element.css('cursor', 'pointer').bind('click', function (event) {
                $(document).bind('keydown.popover', function (event) {
                    if (event.keyCode == 27) {
                        hidePopover();
                        $(document).unbind('keydown.popover');
                    }
                });
                options.left = event.clientX;
                options.top = event.clientY;
                showPopover(popoverId, options, {
                    left: CONTAINER_SCROLL.scrollLeft(),
                    top: CONTAINER_SCROLL.scrollTop()
                });
                return false;
            });
        } else {
            element.hoverIntent({
                over: function (event) {
                    options.left = event.clientX;
                    options.top = event.clientY;
                    showPopover(popoverId, options, {
                        left: CONTAINER_SCROLL.scrollLeft(),
                        top: CONTAINER_SCROLL.scrollTop()
                    });
                },
                out: function () {
                    hidePopoverCallback();
                }
            });
        }


        function hidePopover() {
            var iframe = $('iframe.popover');
            try {
                iframe[0].contentWindow.stopMediaPlayers();
                iframe.fadeOut();
            } catch (exception) {
                iframe.fadeOut(function () {
                    $(this).remove();
                });
            }
            $('div.popover-closing-dialogue').fadeOut(function () {
                $(this).remove();
            });
        }

        function showPopover(popoverId, options, addOffset) {
            $('iframe.popover').hide();
            $('div.popover-closing-dialogue').remove();
            if (options.viewon == 1) {
                $('<div class="popover-closing-dialogue"></div>')
                    .addClass(options.background == 1 ? 'darken' : '')
                    .bind('click', hidePopover)
                    .appendTo('#weave');
            } else if (options.position == 2 || options.position == 3) {
                hidePopoverCallback = function () {
                    $(document).bind('mousemove.popover', function () {
                        $(this).unbind('.popover');
                        hidePopover();
                        hidePopoverCallback = hidePopover;
                    });
                };
            }
            var frame = $('iframe[data-id=' + popoverId + ']');
            if (frame.show().length == 0) {
                var frameSrc;
                if (window.location.protocol === 'file:') {
                    frameSrc = 'popover_' + getResearchId() + '_' + popoverId + '.html';
                } else {
                    frameSrc = '/view/popover/' + getResearchId() + '/' + popoverId + (getApplicationId() ? '?application=' + getApplicationId() : '');
                }
                frame = $('<iframe src="' + frameSrc + '"></iframe>')
                    .attr('data-id', popoverId)
                    .addClass('popover')
                    .addClass('container-loading')
                    .bind('load', function () {
                        frame.removeClass('container-loading');
                    })
                    .appendTo('#weave');
            }
            var top = 0, left = 0, offset = 10;
            switch (options.position) {
                case 0: // left
                    left = Math.max(0, options.left - options.width - offset + addOffset.left);
                    top = options.top + offset + addOffset.top;
                    break;
                    break;
                case 2: // center
                    left = Math.max(0, options.left - options.width / 2) + addOffset.left;
                    top = Math.max(0, options.top - options.height / 2) + addOffset.top;
                    break;
                case 3: // screen center
                    left = CONTAINER_SCROLL.scrollLeft() + Math.max(0, CONTAINER_SCROLL.innerWidth() / 2 - options.width / 2);
                    top = CONTAINER_SCROLL.scrollTop() + Math.max(0, CONTAINER_SCROLL.innerHeight() / 2 - options.height / 2);
                    break;
                default: // right
                    left = options.left + offset + addOffset.left;
                    top = options.top + offset + addOffset.top;
            }
            frame.css({
                top: top + (options.offset.top || 0),
                left: left + (options.offset.left || 0),
                width: options.width,
                height: options.height,
                'box-shadow': options.shadow
            }).bind('mouseover', function () {
                setTimeout(function () {
                    $('iframe.popover').stop().css('opacity', 1);
                    $('div.popover-closing-dialogue').stop().css('opacity', 1);
                }, 10);
            }).bind('mouseout', function () {
                if (options.viewon == 0) {
                    hidePopoverCallback();
                }
            }).bind('click', function () {
                if (options.viewon == 1) {
                    hidePopoverCallback();
                }
            });
        }
    });
}

function initComments() {
    $('.tool-comment').each(function () {
        initComment(this);
    });

    var settings = $.extend({}, {showComments: true}, $.parseJSON($.cookie('view') || '{}'));
    if (!settings.showComments) {
        toggleComments(false);
    }

    updateCommentFilterOptions();
}

function updateCommentFilterOptions() {
    var $commentOptionsContainer = $('#comment-placeholder');
    var options = {};

    $('[data-tool="comment"]').each(function () {
        var el = $(this);
        var creatorId = el.attr('data-creator-id');
        if (!options[creatorId]) {
            options[creatorId] = {
                count: 0,
                name: el.attr('data-creator-name')
            };
        }

        options[creatorId].count++;
    });

    for (var creatorId in options) {
        $('<li><a id="show-resolved-comments" onclick="filterComments(\'' + creatorId + '\')">show ' + options[creatorId].name + '\'s notes (' + options[creatorId].count + ')</a></li>').insertAfter($commentOptionsContainer);
    }

    $commentOptionsContainer.remove();
}

function initComment(item) {
    item = $(item);

    var textarea = $('textarea', item),
        previousTextContent = textarea.val();
    textarea.bind('blur', function () {
        if (textarea.val() == previousTextContent) {
            return;
        }
        textarea.attr('disabled', 'disabled');
        item.addClass('container-loading');
        $.post('/item/update-text-content', {
            item: item.attr('data-id'),
            research: getResearchId(),
            textcontent: textarea.val()
        }, function () {
            previousTextContent = textarea.val();
            item.removeClass('container-loading');
            textarea.removeAttr('disabled');
        })
    });
    $('.icon-remove', item).click(function () {
        Dialog.removeItems([item.attr('data-id')]);
    });
    var weave = $('#weave');
    $('.navigation-prev', item).click(function () {
        var el = item.prevAll('[data-tool="comment"]:first');
        if (el.length === 0) {
            el = weave.children().filter('[data-tool="comment"]').last();
        }
        return false;
    });
    $('.navigation-next', item).click(function () {
        var el = item.nextAll('[data-tool="comment"]:first');
        if (el.length == 0) {
            el = weave.children().filter('[data-tool="comment"]').first();
        }
        if (el) {
            CONTAINER_SCROLL.scrollLeft(el.offset().left - CONTAINER_SCROLL.width() / 2 + item.width() / 2);
            CONTAINER_SCROLL.scrollTop(el.offset().top - CONTAINER_SCROLL.height() / 2 + item.height() / 2);
        }
        return false;
    });

    item
        .draggable({
            stop: function (event, ui) {
                updateTool(this)
            }
        })
        .resizable({
            stop: function (event, ui) {
                updateTool(this, {resize: true})
            }
        });

    $('input[type="checkbox"]', item).bind('change', function () {
        item.toggleClass('comment-resolved');
        $.post('/item/update-tracking', {
            item: item.data('id'),
            research: getResearchId(),
            resolution: $(this).is(':checked') ? 'resolved' : 'open',
            assignee: item.data('assignee-id'),
            date: item.data('date')
        })
    });

    updateTool = function (tool, data) {
        tool = $(tool);
        data = $.extend({
            item: {},
            left: {},
            top: {},
            width: {},
            height: {},
            rotate: {}
        }, data || {});

        var id = tool.data('id');
        data.item[id] = id;
        data.left[id] = parseInt(tool.css('left'));
        data.top[id] = parseInt(tool.css('top'));
        data.width[id] = parseInt(tool.css('width'));
        data.height[id] = parseInt(tool.css('height'));
        data.rotate[id] = parseFloat(tool.attr('data-rotate'));

        $.post('/item/update?research=' + getResearchId(), data, function () {
            reloadNavigationOverview();
        });
    };
}

function addComment() {
    var containerWeave = $('#container-weave'),
        placeholder = $('<div class="tool tool-comment container-loading"></div>').css({
            left: containerWeave.width() / 2 - 100 + containerWeave[0].scrollLeft,
            top: containerWeave.height() / 2 - 100 + containerWeave[0].scrollTop,
            width: 200,
            height: 200
        }).appendTo(weave);

    $.post('/item/add', {
        research: getResearchId(),
        weave: getWeaveId(),
        application: getApplicationId(),
        tool: 'comment',
        file: {},
        left: parseInt(placeholder.css('left')),
        top: parseInt(placeholder.css('top')),
        width: parseInt(placeholder.css('width')),
        height: parseInt(placeholder.css('height'))
    }, function (data) {
        placeholder.replaceWith(data);
        initComment($('[data-id="' + $(data).attr('data-id') + '"]'));
        reloadNavigationOverview();
    });

    toggleComments(true);
}

function stopMediaPlayers() {
    for (var i in mediaPlayers) {
        if (!mediaPlayers[i]) {
            continue;
        }

        mediaPlayerStopCallbacks[i]();
    }
}

function toggleComments(show) {
    var comments = $('.tool-comment'),
        toggleComments = $('#toggle-comments'),
        previousComment = $('#previous-comment'),
        nextComment = $('#next-comment');

    var settings = $.extend({}, {}, $.parseJSON($.cookie('view') || '{}'));
    if (show || toggleComments.text() === 'show notes') {
        settings.showComments = true;
        comments.show();
        nextComment.show();
        previousComment.show();
        toggleComments.text('hide notes');
    } else {
        settings.showComments = false;
        comments.hide();
        nextComment.hide();
        previousComment.hide();
        toggleComments.text('show notes');

    }
    $.cookie('view', JSON.stringify(settings));

    reloadNavigationOverview();
}

function filterComments(value) {
    toggleComments(true);

    $('.tool-comment').each(function () {
        $(this).toggle(
            $(this).attr('data-resolution') === value ||
            $(this).attr('data-creator-id') === value
        )
    })
}

function reloadNavigationOverview() {
    var overviewImage = $('#aspect-overview');
    if (!overviewImage.data('src')) {
        return;
    }
    overviewImage.attr('src', overviewImage.data('src') + '&commentfilter=' + ($('.tool-comment:first').is(':visible') ? '' : -1) + '&t=' + new Date().getTime());
}

function previousComment() {
    if (!comments.length) {
        alert('no notes found');
    }
    if (!selectedComment) {
        navigateToPreviousWeave();
        return;
    } else if (selectedComment.length == 0) {
        selectedComment = WEAVE.children('[data-tool="comment"]:last');
    } else {
        selectedComment = selectedComment.prevAll('[data-tool="comment"]:first');
    }
    if (selectedComment.length == 0) {
        navigateToPreviousWeave();
        return;
    }
    scrollToElement(selectedComment);

    function navigateToPreviousWeave() {
        var prevWeaveId = comments[comments.indexOf(getWeaveId()) - 1];
        if (!prevWeaveId) {
            prevWeaveId = comments[comments.length - 1];
        }
        if (prevWeaveId == getWeaveId()) {
            selectedComment = [];
            previousComment()
        } else {
            navigateToWeave(prevWeaveId);
        }
    }
}

function nextComment() {
    if (!comments.length) {
        alert('no notes found');
        return;
    }
    var filter = '[data-tool="comment"]:first';
    if (!selectedComment || selectedComment.length == 0) {
        selectedComment = WEAVE.children(filter);
    } else {
        selectedComment = selectedComment.nextAll(filter);
    }
    if (selectedComment.length == 0) {
        var nextWeaveId = comments[comments.indexOf(getWeaveId()) + 1];
        if (!nextWeaveId) {
            nextWeaveId = comments[0];
        }
        if (nextWeaveId == getWeaveId()) {
            nextComment()
        } else {
            navigateToWeave(nextWeaveId, 'note');
        }
    } else {
        scrollToElement(selectedComment);
    }
}

function navigateToWeave(weaveId, initAction) {
    var newUrl = location.href.replace('/' + getWeaveId(), '/' + weaveId);
    if (initAction) {
        if (newUrl.indexOf('#') !== -1) {
            newUrl = newUrl.replace(/#\w*/, '#' + initAction);
        } else {
            newUrl += '#' + initAction;
        }
    }
    location.href = newUrl;
}

function scrollToElement(el) {
    CONTAINER_SCROLL.scrollLeft(el.position().left - CONTAINER_SCROLL.width() / 2 + el.width() / 2);
    CONTAINER_SCROLL.scrollTop(el.position().top - CONTAINER_SCROLL.height() / 2 + el.height() / 2);
}

function detectMissingFonts() {
    if (!showMissingFontsHint) {
        return;
    }

    var textTools = $('[style]', '.tool-text'),
        fontsToBeChecked = {},
        fontDetector = new Detector(),
        ignoreFonts = ['opensans', 'terminal'],
        missingFonts = [];

    textTools.each(function () {
        if ($(this)[0].style.fontFamily) {
            var fontFamilyList = $(this)[0].style.fontFamily.split(','),
                fontName;
            for (var i in fontFamilyList) {
                if (i > 0) break;
                fontName = fontFamilyList[i].replace(/'|"/ig, '').trim();
                fontsToBeChecked[fontName.replace(/ /ig, '').toLowerCase()] = fontName;
            }
        }
    });

    for (var i in fontsToBeChecked) {
        if (ignoreFonts.indexOf(i) !== -1) {
            continue;
        }
        if (fontDetector.detect(fontsToBeChecked[i])) {
            continue;
        }

        missingFonts.push(fontsToBeChecked[i]);
    }

    if (missingFonts.length > 0) {
        var hint = $('#missing-fonts-hint');
        if (hint.length == 0) {
            hint = $('<div id="missing-fonts-hint"></div>');
        }
        hint.html('Some fonts could not be loaded: ' + missingFonts.join(', ') + '. Not all elements on the page may look as intended.')
            .append($('<span class="ui-icon-close ui-icon"></span>').bind('click', function () {
                showMissingFontsHint = false;
                hint.remove();
                $('body').removeClass('missing-fonts-hint-visible');
            }))
            .insertAfter('#zoom-hint');
        $('body').addClass('missing-fonts-hint-visible');
    }
}

function detectZoomLevel() {
    var zoomHint = $('#zoom-hint');
    swfZoomDetection.init({
        onZoomChange: function (obj) {
            if (zoomHint == null) return;
            zoomHint.html('You are currently viewing this page at ' + Math.round(obj.scale * 100) + '% zoom. The page is optimised for 100%: not all elements on the page may look as intended.');
            if (obj.scale == 1) {
                zoomHint.hide();
                $('body').removeClass('zoom-hint-visible');
            } else {
                zoomHint.show();
                $('body').addClass('zoom-hint-visible');
            }
            $('<span class="ui-icon-close ui-icon"></span>').bind('click', function () {
                zoomHint.remove();
                zoomHint = null;
                $('body').removeClass('zoom-hint-visible');
            }).appendTo('#zoom-hint');
        },
        getInitIfOne: true,
        initCallOnly: false,
        frameRate: 25
    });
}

var mediaPlayers = {};
var mediaPlayerCounter = {};
var mediaPlayerStopCallbacks = {};

var pausePlayersExceptOfThis = function (playerId) {
    $.each(mediaPlayerStopCallbacks, function (key, mediaPlayerStopCallbacks) {
        if (key === playerId) {
            return;
        }

        mediaPlayerStopCallbacks();
    });
};

function initPlayTool() {
    var playTools = $('.tool-play[data-id]');

    playTools.click(function () {
        var playTool = $(this);

        if (playTool.attr('data-state') != 'PLAYING') {
            triggerPlayEvent(playTool);
        } else {
            triggerPauseEvent(playTool);
        }
    }).each(function () {
        $('.content', this).last().hide();
        $(this).attr('data-state', 'IDLE');

        var players = $.parseJSON($(this).attr('data-players'));
        if (!players) {
            return;
        }

        for (var i = 0; i < players.length; i++) {
            mediaPlayers[players[i]] = false;
        }
    });

    setInterval(function () {
        playTools.each(function () {
            var status = true;
            var players = $.parseJSON($(this).attr('data-players'));
            if (!players) {
                return;
            }

            for (var i = 0; i < players.length; i++) {
                if (mediaPlayers[players[i]] === false) {
                    status = false;
                    break;
                }
            }

            changePlayToolState($(this), status);
        });
    }, 500);

    var triggerPlayEvent = function (playTool) {
        var options = $.parseJSON(playTool.attr('data-options'));
        var players = $.parseJSON(playTool.attr('data-players'));

        if (options.pauseOtherPlayers == true) {
            pausePlayersExceptOfThis(playTool.attr('data-id'));
        }

        changePlayToolState(playTool, true);
        updatePlayersState(players, true);
    };
    var triggerPauseEvent = function (playTool) {
        var players = $.parseJSON(playTool.attr('data-players'));

        changePlayToolState(playTool, false);
        updatePlayersState(players, false);
    };
    var changePlayToolState = function (playTool, status) {
        if (status === true) {
            $('.content:first', playTool).hide();
            $('.content:last', playTool).show();
            playTool.attr('data-state', 'PLAYING');
        } else {
            $('.content:last', playTool).hide();
            $('.content:first', playTool).show();
            playTool.attr('data-state', 'IDLE');
        }
    };
    var updatePlayersState = function (players, status) {
        $.each(players, function () {
            var player = this;
            var tool = $('[data-id=' + player + ']');
            var jwplayerId = (tool.hasClass('tool-video') ? 'video' : 'audio') + '-' + player;

            if (status) {
                tool.trigger('click');
                jwplayer(jwplayerId).play();
            } else {
                jwplayer(jwplayerId).pause();
            }

            mediaPlayers[player] = status;
        });
    };
}

function Dialog() {

}

Dialog.toParam = function (ids, key) {
    return $(ids).map(function () {
        return key + '[]=' + this;
    }).toArray().join('&');
};
Dialog.removeItems = function (ids) {
    new DialogForm({
        url: '/item/remove?' + Dialog.toParam(ids, 'item') + '&research=' + getResearchId(),
        eAfterValidSubmit: function () {
            Editor.removeItems(ids);
        }
    });
};

function Editor() {
}

function collectMetric(key, value, tags) {
    if (location.protocol === 'file:') {
        return;
    }

    $.post('/metrics', {
        m: 'c',
        k: key,
        v: value,
        t: $.extend({}, tags, {
            research: getResearchId(),
            weave: getWeaveId()
        })
    })
}

function onYouTubePlayerAPIReady() {
    $('iframe[data-provider="youtube"]').each(function () {
        var $iframe = $(this);
        var playerId = $iframe.attr('id').replace(/player-/, '');
        var player = new YT.Player("player-" + playerId, {
            events: {
                "onReady": function (event) {
                    if ($iframe.data('autoplay')) {
                        event.target.playVideo();
                    }
                },
                "onStateChange": function (event) {
                    mediaPlayers[playerId] = (event.data === YT.PlayerState.PLAYING || event.data === YT.PlayerState.BUFFERING);

                    if ($iframe.data('stopotherplayers') && mediaPlayers[playerId]) {
                        pausePlayersExceptOfThis(playerId);
                    }

                    if ($iframe.data('loop') && event.data === YT.PlayerState.ENDED) {
                        event.target.playVideo();
                    }
                }
            }
        });

        mediaPlayerStopCallbacks[playerId] = function () {
            player.pauseVideo();
        }
    });
}

function trackVisitDuration() {

    const start = new Date().getTime();

    if (location.protocol === 'file:') {
        return;
    }

    $(window).bind('unload', function () {
        const url = '/metrics/visit-duration?research=' + getResearchId(),
            data = {
                m: 't',
                k: 'analytics.visit_duration',
                v: new Date().getTime() - start
            };

        let formData = new FormData();

        for (let key in data) {
            if (data.hasOwnProperty(key)) {
                formData.append(key, data[key]);
            }
        }

        if ($.isFunction(navigator.sendBeacon)) {
            navigator.sendBeacon(url, formData);
        } else {
            $.post(url, formData);
        }
    });
}

function disableLoopAfterTooManyIterations(jwplayer) {
    var id = jwplayer.id;

    if (!jwplayer.getConfig('repeat')) {
        return;
    }

    if (!mediaPlayerCounter[id]) {
        mediaPlayerCounter[id] = 1;
    } else if (++mediaPlayerCounter[id] > 10) {
        jwplayer.setConfig({repeat: false});
    }
}

function autostartNotAllowed(id) {
    autoStartItems.push(id);

    $('#navigation-tooltip').hide();
    $('#autostart-tooltip').show();
}

Editor.getSettings = function () {
    return $.extend({}, $.parseJSON($.cookie('editor') || '{}'), {
        overview: false,
        commands: false,
        textchanges: false,
        gridsize: 50,
        snaptogrid: false
    });
};
Editor.removeItems = function (ids) {
    for (var i in ids) {
        $('[data-id="' + ids[i] + '"]').remove();
    }
    reloadNavigationOverview();
};

Array.prototype.indexOf = function (obj, fromIndex) {
    if (fromIndex == null) {
        fromIndex = 0;
    } else if (fromIndex < 0) {
        fromIndex = Math.max(0, this.length + fromIndex);
    }
    for (var i = fromIndex, j = this.length; i < j; i++) {
        if (this[i] == obj)
            return i;
    }
    return -1;
};

$(window).bind('beforeunload', function () {
    stopMediaPlayers();
});
