function addEntry(type, args, dialog) {
    args = args || {};
    if ($('#sarmember').is(':checked')) {
        args.sarmember = 1;
    }

    var argString = $.map(args, function (value, key) {
        return encodeURIComponent(key) + '=' + encodeURIComponent(value);
    }).join('&');

    new DialogForm({
        url: '/admin/' + type + '/add?context=' + $('#context').val() + '&' + argString,
        insertResponseOnSuccess: '#container-content',
        dialog: dialog || {}
    });
}
function editEntry(type, id, dialog) {
    if (typeof id === 'undefined') {
        id = '';
    } else if (!isNaN(id)) {
        id = type + '=' + id;
    }

    var args = '';
    if ($('#sarmember').is(':checked')) {
        args += '&sarmember=1';
    }

    new DialogForm({
        url: '/admin/' + type + '/edit?context=' + $('#context').val() + args + '&' + id,
        dialog: dialog || {},
        insertResponseOnSuccess: '#container-content'
    });
}
function duplicateEntry(type, id) {
    if (typeof id === 'undefined') {
        id = '';
    } else if (!isNaN(id)) {
        id = type + '=' + id;
    }

    var args = '';
    if ($('#sarmember').is(':checked')) {
        args += '&sarmember=1';
    }

    new DialogForm({
        url: '/admin/' + type + '/duplicate?context=' + $('#context').val() + args + '&' + id,
        insertResponseOnSuccess: '#container-content'
    });
}
function removeEntry(type, id) {
    if (typeof id == 'undefined') {
        id = '';
    } else if (!isNaN(id)) {
        id = type + '=' + id;
    }

    var args = '';
    if ($('#sarmember').is(':checked')) {
        args += '&sarmember=1';
    }

    new DialogForm({
        url: '/admin/' + type + '/remove?context=' + $('#context').val() + args + '&' + id,
        insertResponseOnSuccess: '#container-content'
    });
}
function manipulateEntry(type, action, id) {
    if (typeof id == 'undefined') {
        id = '';
    } else if (!isNaN(id)) {
        id = type + '=' + id;
    }
    new DialogForm({
        url: '/admin/' + type + '/' + action + '?context=' + $('#context').val() + '&' + id,
        insertResponseOnSuccess: '#container-content'
    });
}
function exportEntry(id) {
    window.open('/admin/research/export?context=' + $('#context').val() + '&research=' + id);
}
function applicationExport(id) {
    new DialogForm({
        url: '/admin/application/export?context=' + $('#context').val() + '&application=' + id,
        submitInNewTab: true
    });
}
function applicationReviewExport(id) {
    window.open('/admin/application/review-export?context=' + $('#context').val() + '&application=' + id);
}
function updateApplicationExportSelection(id) {
    $.ajax({
        type: 'GET',
        url: '/admin/application/favorite?context=' + $('#context').val() + '&application-favorite=' + id,
        dataType: "json",
        success: function (data) {
            $.each(data, function (tab, values) {
                $.each(values, function (field, value) {
                    $('[name="' + tab + '[' + field + ']"]').prop('checked', +value);
                });
            });
            $('[role=dialog] form').submit();
            $('[role=dialog] form').submit();
        }
    });
}
function switchUser(id) {
    new DialogForm({
        url: '/admin/user/switch?context=' + $('#context').val() + '&user=' + id,
        eAfterValidSubmit: function () {
            location.href = '/profile';
        },
        closeOnSuccess: true
    });
}
function sendMail(id) {
    new DialogForm({
        url: '/admin/portal/send-mail?context=' + $('#context').val() + '&portal=' + id,
        closeOnSuccess: true,
        asyncFileUpload: false
    });
}
function createResearchPortalComment(id) {
    new DialogForm({
        url: '/admin/research/portal-comment?context=' + $('#context').val() + '&research=' + id,
        closeOnSuccess: true
    });
}
function exportView() {
    window.open(document.location.href + '&export=csv');
}
function portalMailAccept(id) {
    new DialogForm({
        url: '/admin/portal/mail-accept?context=' + $('#context').val() + '&newsletter=' + id,
        insertResponseOnSuccess: '#container-content'
    });
}
function portalMailDecline(id) {
    new DialogForm({
        url: '/admin/portal/mail-decline?context=' + $('#context').val() + '&newsletter=' + id,
        insertResponseOnSuccess: '#container-content'
    });
}

function initFormElementCreator($tabContainer) {
    var $elementCreator = $('[name="elements[formelementcreator]"]', $tabContainer),
        $elementInfo = $('#frm-elements-titleinfo'),
        $elementsTabContainer = $elementCreator.closest('div[id^=tab]'),
        $formElementContainer = $elementsTabContainer.find('div[id^=accordion]'),
        $prototypeTab = $tabContainer.children().last(),
        creationCounter = 0;

    $('.ui-tabs-nav .ui-tabs-nav-item:last-child', $tabContainer).hide();

    $formElementContainer.find('[name="elements[element][placeholder][element]"]').closest('div').parent().remove();
    $formElementContainer.children('div').each(function () {
        updateFormElementAccordionHeader($(this), true);
    });

    $elementCreator.change(function () {
        var $select = $(this),
            type = $select.val();

        if (!type) {
            return;
        }

        var $prototype = $('input[value="' + type + '"]', $prototypeTab).closest('div').parent();
        $('[data-tagit]', $prototype).tagit('destroy');

        var $newElement = $prototype.clone().appendTo($formElementContainer);
        $newElement.find('[name]').each(function () {
            $(this).attr('name', $(this).attr('name').replace(/^prototype/, 'elements').replace(/\[]/, '[' + creationCounter + ']'));
        });
        $('[data-tagit]', $newElement).each(function () {
            $(this).tagit(JSON.parse($(this).attr('data-tagit')));
        });

        $newElement.find('input[id*=identifier]').val('custom_element_' + type + '_' + new Date().getTime());

        var elementCount = $('h3', $formElementContainer).length;
        var accordionOptions = $formElementContainer.accordion('option');
        $formElementContainer.accordion('destroy').accordion(accordionOptions);
        $formElementContainer.accordion("option", "active", elementCount - 1);

        $select.val('');
        creationCounter++;
    }).parent().prependTo($elementsTabContainer);
    $elementInfo.insertBefore($elementCreator);
}

function updateFormElementAccordionHeader($container, init) {
    var $label = $container.find('label:first').next('input');
    var $title = $('h3 a', $container);
    var $actions = $title.find('i');
    var $type = $container.find('input[id*=element]');
    var $elementLabel = $('[name="elements[formelementcreator]"] option[value="' + $type.val() + '"]').text();

    $title.html(($label.val() || 'no label' ).replace(/\./, '&#8228;') + ' [' + $elementLabel + ']');
    $title.append($actions);

    var $identifier = $container.find('input[id*=identifier]');
    if ($identifier.attr('disabled') !== 'disabled' && $label.val()) {
        $identifier.val('custom_element_' + $label.val().toLowerCase().replace(/[^a-z0-9]/gm, '_').replace(/^_/, ''));
    }

    if (init === true && $label.val() === '') {
        $identifier.removeAttr('disabled');
    }
}

function initApplicationProgramPortalFilter($selectAccessGroup, $selectApplicantPortal) {
    $($selectAccessGroup).bind('change', function () {
        $($selectApplicantPortal).parent().toggle($(this).val() == 'applicant').stop();
    }).trigger('change');
}

function handleExistingUser(user) {
    $.get('/user/search?hidden-profile=true&property=name&value=' + encodeURI(user), function (data) {
        var existingUser = null;
        $.each(data, function (key, entry) {
            if (entry.label === user) {
                existingUser = entry.value;
                return false;
            }
        });

        if (existingUser) {
            new DialogForm({
                url: '/admin/user/add-to-portal?context=' + $('#context').val() + '&user=' + encodeURI(existingUser),
                reloadOnSuccess: true
            });
        }
    });
}
function switchContext(context) {
    if (location.href.indexOf('context') !== -1) {
        location.href = location.href.replace(/context=\d+/, 'context=' + context);
    } else if (location.href.indexOf('?') !== -1) {
        location.href += '&context=' + context;
    } else {
        location.href += '?context=' + context;
    }
}