tinyMCEPopup.requireLangPack();

var LinkDialog = {
    preInit: function () {
        var url;

        if (url = tinyMCEPopup.getParam("external_link_list_url"))
            document.write('<script language="javascript" type="text/javascript" src="' + tinyMCEPopup.editor.documentBaseURI.toAbsolute(url) + '"></script>');
    },

    selectTab: function (tab) {
        if (document.getElementById(tab + '_tab').hasAttribute('disabled')) {
            return;
        }
        mcTabs.displayTab(tab + '_tab', tab + '_panel');
        if (this.isNew) {
            document.forms[0].insert.value = tinyMCEPopup.editor.translate('advanced_dlg.insert_' + tab);
        } else {
            document.forms[0].insert.value = tinyMCEPopup.editor.translate('advanced_dlg.edit_' + tab);
        }
        document.forms[0].link_type.value = tab;
    },

    init: function () {
        var f = document.forms[0], ed = tinyMCEPopup.editor;

        // Setup browse button
        document.getElementById('hrefbrowsercontainer').innerHTML = getBrowserHTML('hrefbrowser', 'href', 'file', 'theme_advanced_link');
        if (isVisible('hrefbrowser'))
            document.getElementById('href').style.width = '180px';

        this.fillClassList('class_list');
        this.fillFileList('link_list', 'tinyMCELinkList');
        this.fillTargetList('target_list');

        if (e = ed.dom.getParent(ed.selection.getNode(), 'A')) {
            f.href.value = ed.dom.getAttrib(e, 'href');
            f.linktitle.value = ed.dom.getAttrib(e, 'title');
            f.insert.value = ed.getLang('update');
            selectByValue(f, 'link_list', f.href.value);
            selectByValue(f, 'target_list', ed.dom.getAttrib(e, 'target'));
            selectByValue(f, 'class_list', ed.dom.getAttrib(e, 'class'));
        }

        var popovers = window.top.Editor.PopoverList.items();
        for (var i in popovers) {
            if (popovers.hasOwnProperty(i)) {
                f.popover_list.options[f.popover_list.options.length] = new Option(popovers[i].label, popovers[i].id);
            }
        }

        this.isNew = (!e || ed.dom.getAttrib(e, 'href') === null);

        var selectionContent = ed.selection.getContent({format: 'text'}) || (e && e.textContent);
        if (e && ed.dom.getAttrib(e, 'data-popover-options') != '') {
            var options = JSON.parse(ed.dom.getAttrib(e, 'data-popover-options'));
            f.popover_title.value = options.title || selectionContent || '';
            f.popover_text.value = options.text || '';
            selectByValue(f, 'creation_type_list', options.creation_type);
            selectByValue(f, 'popover_list', options.popover);
            selectByValue(f, 'view_on_list', options.viewon);
            selectByValue(f, 'position_list', options.position);
            selectByValue(f, 'background_list', options.background);
            f.autocontent.value = options.autocontent ? 1 : 0;
            f.href.value = '';
            LinkDialog.selectTab('popover');
        } else if (!selectionContent) {
            f.autocontent.value = 1;
            f.popover_title.value = '';
        } else {
            f.autocontent.value = 0;
            f.popover_title.value = selectionContent;
            LinkDialog.selectTab('general');
        }

        if (f.autocontent.value == 1) {
            LinkDialog.selectTab('popover');
            var linkTab = document.getElementById('general_tab');
            linkTab.setAttribute('disabled', '');
            linkTab.childNodes[0].childNodes[0].style.color = 'grey';
            linkTab.parentNode.replaceChild(linkTab.cloneNode(true), linkTab);
        }

        if (window.top.Editor.isPopover()) {
            LinkDialog.selectTab('general');
            var popoverTab = document.getElementById('popover_tab');
            popoverTab.setAttribute('disabled', '');
            popoverTab.childNodes[0].childNodes[0].style.color = 'grey';
            popoverTab.parentNode.replaceChild(popoverTab.cloneNode(true), popoverTab);
        }

        var duplicatePopover = f.popover_list,
            textPopover = f.popover_text;

        f.creation_type_list.onchange = function () {
            duplicatePopover.style.display = 'none';
            textPopover.style.display = 'none';

            switch (getSelectValue(f, 'creation_type_list')) {
                case 'duplicate':
                    duplicatePopover.style.display = '';
                    break;
                case 'text':
                    textPopover.style.display = '';
                    break;
            }
        };
        f.creation_type_list.onchange();

        if (e && ed.dom.getAttrib(e, 'data-popover') != '') {
            document.getElementById('creation_type_row').style.display = 'none';
            document.getElementById('selection_row').style.display = 'none';
        }

        (function () {
            var element = tinyMCEPopup.getWin();
            if (!element) {
                return;
            }
            element = element.document.getElementsByClassName('mceTop');
            if (element.length == 0) {
                return;
            }
            element = element[0].getElementsByTagName('span');
            if (element.length == 0) {
                return;
            }
            if (window.top.Editor.isPopover()) {
                element[0].innerHTML = 'Insert/Edit Link';
            } else {
                element[0].innerHTML = (f.autocontent.value == 1 ? 'Insert/Edit Auto Numbering Footnote' : 'Insert/Edit Link or Footnote');
            }
        })();
    },

    update: function () {
        var f = document.forms[0], ed = tinyMCEPopup.editor, e, b, href = f.href.value.replace(/ /g, '%20'), attribs;

        tinyMCEPopup.restoreSelection();
        if (f.link_type.value == 'popover' && f.autocontent.value == 1) {
            tinyMCEPopup.execCommand('mceInsertContent', false, ed.dom.createHTML('a', {href: '#'}, 'x'));
            tinymce.each(ed.dom.select("a"), function (n) {
                if (ed.dom.getAttrib(n, 'href') == '#') {
                    e = n;
                }
            });
        } else {
            e = ed.dom.getParent(ed.selection.getNode(), 'A');
        }

        if (f.link_type.value == 'popover') {
            attribs = {
                'href': '#',
                'data-popover': ed.dom.getAttrib(e, 'data-popover') || null,
                'data-popover-options': JSON.stringify({
                    title: f.popover_title.value,
                    creation_type: getSelectValue(f, 'creation_type_list'),
                    popover: getSelectValue(f, 'popover_list'),
                    text: f.popover_text.value,
                    viewon: getSelectValue(f, 'view_on_list'),
                    position: getSelectValue(f, 'position_list'),
                    background: getSelectValue(f, 'background_list'),
                    changed: true,
                    autocontent: f.autocontent.value == 1 ? true : false
                }),
                'data-popover-auto': f.autocontent.value
            };
        } else {
            // Remove element if there is no href
            if (!f.href.value) {
                if (e) {
                    b = ed.selection.getBookmark();
                    ed.dom.remove(e, 1);
                    ed.selection.moveToBookmark(b);
                    tinyMCEPopup.execCommand("mceEndUndoLevel");
                    tinyMCEPopup.close();
                    return;
                }
            }

            attribs = {
                href: href,
                title: f.linktitle.value,
                target: f.target_list ? getSelectValue(f, "target_list") : null,
                'class': f.class_list ? getSelectValue(f, "class_list") : null
            };
        }

        // Create new anchor elements
        if (e == null) {
            ed.getDoc().execCommand("unlink", false, null);
            tinyMCEPopup.execCommand("mceInsertLink", false, "#mce_temp_url#", {skip_undo: 1});

            tinymce.each(ed.dom.select("a"), function (n) {
                if (ed.dom.getAttrib(n, 'href') == '#mce_temp_url#') {
                    e = n;
                    ed.dom.setAttribs(e, attribs);
                }
            });
        } else {
            ed.dom.removeAllAttribs(e);
            ed.dom.setAttribs(e, attribs);
        }

        // Don't move caret if selection was image
        if (e.childNodes.length != 1 || e.firstChild.nodeName != 'IMG') {
            ed.focus();
            ed.selection.select(e);
            ed.selection.collapse(0);
            tinyMCEPopup.storeSelection();
        }

        tinyMCEPopup.execCommand("mceEndUndoLevel");
        tinyMCEPopup.close();
    },

    checkPrefix: function (n) {
        if (n.value && Validator.isEmail(n) && !/^\s*mailto:/i.test(n.value) && confirm(tinyMCEPopup.getLang('advanced_dlg.link_is_email')))
            n.value = 'mailto:' + n.value;

        if (/^\s*www\./i.test(n.value) && confirm(tinyMCEPopup.getLang('advanced_dlg.link_is_external')))
            n.value = 'http://' + n.value;
    },

    fillFileList: function (id, l) {
        var dom = tinyMCEPopup.dom, lst = dom.get(id), v, cl;

        l = window[l];

        if (l && l.length > 0) {
            lst.options[lst.options.length] = new Option('', '');

            tinymce.each(l, function (o) {
                lst.options[lst.options.length] = new Option(o[0], o[1]);
            });
        } else
            dom.remove(dom.getParent(id, 'tr'));
    },

    fillClassList: function (id) {
        var dom = tinyMCEPopup.dom, lst = dom.get(id), v, cl;

        if (v = tinyMCEPopup.getParam('theme_advanced_styles')) {
            cl = [];

            tinymce.each(v.split(';'), function (v) {
                var p = v.split('=');

                cl.push({'title': p[0], 'class': p[1]});
            });
        } else
            cl = tinyMCEPopup.editor.dom.getClasses();

        if (cl.length > 0) {
            lst.options[lst.options.length] = new Option(tinyMCEPopup.getLang('not_set'), '');

            tinymce.each(cl, function (o) {
                lst.options[lst.options.length] = new Option(o.title || o['class'], o['class']);
            });
        } else
            dom.remove(dom.getParent(id, 'tr'));
    },

    fillTargetList: function (id) {
        var dom = tinyMCEPopup.dom, lst = dom.get(id), v;

        lst.options[lst.options.length] = new Option(tinyMCEPopup.getLang('not_set'), '');
        lst.options[lst.options.length] = new Option(tinyMCEPopup.getLang('advanced_dlg.link_target_same'), '_self');
        lst.options[lst.options.length] = new Option(tinyMCEPopup.getLang('advanced_dlg.link_target_blank'), '_blank');

        if (v = tinyMCEPopup.getParam('theme_advanced_link_targets')) {
            tinymce.each(v.split(','), function (v) {
                v = v.split('=');
                lst.options[lst.options.length] = new Option(v[0], v[1]);
            });
        }
    }
};

LinkDialog.preInit();
tinyMCEPopup.onInit.add(LinkDialog.init, LinkDialog);
