<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Doctrine\Common;

use Doctrine\Common\PropertyChangedListener;

trait NotifyPropertyChangedTrait
{

    /**
     * @var PropertyChangedListener[]
     */
    protected $listeners = [];

    /**
     * @param PropertyChangedListener $listener
     */
    public function addPropertyChangedListener(PropertyChangedListener $listener)
    {
        $this->listeners[] = $listener;
    }

    /**
     * @param string $propName
     * @param mixed $oldValue
     * @param mixed $newValue
     */
    protected function onPropertyChange($propName, $oldValue, $newValue)
    {
        foreach ($this->listeners as $listener) {
            $listener->propertyChanged($this, $propName, $oldValue, $newValue);
        }
    }
}