<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\LayoutElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Application\Form\LayoutElement;

/**
 * @ODM\EmbeddedDocument
 */
class DescriptionLayoutElement extends LayoutElement
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $description;

    /**
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'value' => $this->description,
        ];
        return $options + parent::getFormOptions();
    }

}