<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\LayoutElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Application\Form\LayoutElement;

/**
 * @ODM\EmbeddedDocument
 */
class HeadlineLayoutElement extends LayoutElement
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $headline;

    /**
     * @return string
     */
    public function getHeadline()
    {
        return $this->headline;
    }

    /**
     * @param string $headline
     */
    public function setHeadline($headline)
    {
        $this->headline = $headline;
    }

    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'value'      => '<h4 style="margin-bottom:3px; font-weight: bold">' . htmlentities($this->headline) . '</h4>',
            'validators' => [
                ['StringLength', false, [0, 200]],
            ],
        ];
        return $options + parent::getFormOptions();
    }

}