<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Core\Revision;

use JMS\Serializer\Annotation as ODS;
use Rc\Domain\Model\ModelInterface;

/**
 * @mixin ModelInterface
 */
trait RevisionAwareTrait
{

    /**
     * @var array
     * @ODS\Type(name="array")
     */
    private $revisionComments = [];

    /**
     * @param string $label
     */
    public function addRevisionComment($label)
    {
        $this->revisionComments[$label] = true;
    }

    /**
     * @return array
     */
    public function getRevisionComments()
    {
        return array_keys($this->revisionComments);
    }

    /**
     * @return boolean
     */
    public function hasRevisionComments()
    {
        return count($this->revisionComments) > 0;
    }
}