<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Media\Resource;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Media\Resource;
use Rc\Domain\Model\Research\Exposition\Weave\Generic\PlayableAwareInterface;

/**
 * @ODM\EmbeddedDocument
 */
class AudioResource extends Resource implements PlayableAwareInterface
{

    const DERIVATIVE_TYPE_MP3 = 'mp3';

    /**
     * @var float
     * @ODM\Field(type="float")
     */
    protected $duration;

    /**
     * @return float
     */
    public function getDuration()
    {
        return $this->duration;
    }

    /**
     * @param float $duration
     */
    public function setDuration($duration)
    {
        $this->duration = $duration;
    }
}