<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Media\Resource\Type;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\EmbeddedDocument
 */
class ResolutionType
{
    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $x;

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $y;

    /**
     * @param int $x
     * @param int $y
     */
    public function __construct($x = null, $y = null)
    {
        $this->setX($x);
        $this->setY($y);
    }

    /**
     * @return int
     */
    public function getX()
    {
        return $this->x;
    }

    /**
     * @param int $x
     */
    public function setX($x)
    {
        $this->x = (int)$x;
    }

    /**
     * @return int
     */
    public function getY()
    {
        return $this->y;
    }

    /**
     * @param int $y
     */
    public function setY($y)
    {
        $this->y = (int)$y;
    }

    /**
     * @return string
     */
    public function __toString()
    {
        return $this->x . 'x' . $this->y;
    }
}