<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model;

interface ModelInterface
{
    const VAL_TITLE_LENGTH_MIN = 4;
    const VAL_TITLE_LENGTH_MAX = 255;
    const VAL_DESCRIPTION_LENGTH_MIN = 10;
    const VAL_DESCRIPTION_LENGTH_MAX = 5000;

    /**
     * @return string
     */
    public function getUuid();

    /**
     * @return int
     */
    public function getId();

    /**
     * @param string|bool $format
     * @return \DateTime|string
     */
    public function getCreated($format = true);

    /**
     * @param string|bool $format
     * @return \DateTime|string
     */
    public function getModified($format = true);

    /**
     * @return boolean
     */
    public function getDeleted();

    /**
     * @return string
     */
    public function __toString();

    /**
     * @param array $values
     * @return $this
     */
    public function setValues(array $values);

    /**
     * @deprecated
     *
     * @return array
     */
    public function getValues();
}