<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research;

use Rc\Domain\Model\Research;

/**
 * @mixin Research
 */
trait DoiAwareTrait
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $doi;

    /**
     * @return string
     */
    public function getDoi()
    {
        return $this->doi;
    }

    /**
     * @param string $doi
     */
    public function setDoi($doi)
    {
        $this->doi = $doi;
    }

    /**
     * @return string
     */
    public function getDoiUrl()
    {
        if (!isset($this->doi)) {
            return null;
        }
        return 'https://doi.org/' . $this->doi;
    }
}
