<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research\Exposition\TableOfContent\Anchor;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\TableOfContent\Anchor;

/**
 * @ODM\EmbeddedDocument()
 */
class Headline extends Anchor
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $id;

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $level;

    /**
     * @param string $id
     * @param int $level
     */
    public function __construct($id, $level)
    {
        $this->id = $id;
        $this->level = $level;
    }

    /**
     * @return array
     */
    public function toArray()
    {
        return ['id' => $this->id, 'level' => $this->level];
    }
}