<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\MediaInterface;
use Rc\Domain\Model\Research\Exposition\SimpleMedia\ImageSimpleMedia;

interface BackgroundAwareInterface
{
    /**
     * @return array
     */
    public static function getBackgroundImageStyles();

    /**
     * @return array
     */
    public static function getBackgroundImagePositions();

    /**
     * @return array
     */
    public static function getBackgroundImageSizes();

    /**
     * @return string
     */
    public function getBackgroundColor();

    /**
     * @param string $color
     */
    public function setBackgroundColor($color);

    /**
     * @return string
     */
    public function getBackgroundImageStyle();

    /**
     * @param string $imageStyle
     */
    public function setBackgroundImageStyle($imageStyle);

    /**
     * @return string
     */
    public function getBackgroundImagePosition();

    /**
     * @param string $imagePosition
     */
    public function setBackgroundImagePosition($imagePosition);

    /**
     * @return string
     */
    public function getBackgroundImageSize();

    /**
     * @param string $imageSize
     */
    public function setBackgroundImageSize($imageSize);

    /**
     * @return MediaInterface
     */
    public function getBackgroundImage();

    /**
     * @param ImageSimpleMedia $image
     */
    public function setBackgroundImage(ImageSimpleMedia $image);

    /**
     * @return bool
     */
    public function hasBackgroundImage();

    /**
     * @param int|null $width
     * @param int|null $height
     * @return string|null
     */
    public function getBackgroundImageUrl($width = null, $height = null);
}