<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Rc\Domain\Model\Media\Dimension;

interface DimensionAwareInterface
{
    /**
     * @return int
     */
    public function getWidth();

    /**
     * @param int $width
     * @return $this
     */
    public function setWidth($width);

    /**
     * @return int
     */
    public function getHeight();

    /**
     * @param int $height
     * @return $this
     */
    public function setHeight($height);

    /**
     * @return bool
     */
    public function hasAspectRatio();

    /**
     * @return string
     */
    public function getAspectRatio();

    /**
     * @return string
     */
    public function getDisplayAspectRatio();

    /**
     * @return Dimension
     */
    public function getDimension();

}