<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\SimpleMedia\ImageSimpleMedia;
use Rc\Domain\Model\Research\Exposition\SimpleMediaInterface;

interface ImageAwareInterface
{

    /**
     * @param SimpleMediaInterface $parent
     * @param ImageSimpleMedia|null $image
     */
    public function setImage(SimpleMediaInterface $parent, ImageSimpleMedia $image = null);

    /**
     * @param SimpleMediaInterface $parent
     * @return bool
     */
    public function hasImage(SimpleMediaInterface $parent);

    /**
     * @param SimpleMediaInterface $parent
     * @return ImageSimpleMedia|null
     */
    public function getImage(SimpleMediaInterface $parent);

    /**
     * @param SimpleMediaInterface $parent
     * @return null
     */
    public function getImageId(SimpleMediaInterface $parent);

    /**
     * @return ImageSimpleMedia[]
     */
    public function getImages();

    /**
     * @deprecated
     */
    public function getImageRevisions();

    /**
     * @deprecated
     */
    public function useRevisionForImages();

    /**
     * @deprecated
     */
    public function resetRevisionForImages();
}