<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Weave\Style\PositionStyle;

trait PaddingAwareTrait
{
    /**
     * @var PositionStyle
     * @ODM\EmbedOne(targetDocument="Rc\Domain\Model\Research\Exposition\Weave\Style\PositionStyle")
     */
    protected $padding;

    /**
     * @return int
     */
    public function getPaddingTop()
    {
        return $this->padding->getTop();
    }

    /**
     * @param int $paddingTop
     */
    public function setPaddingTop($paddingTop)
    {
        $this->padding->setTop($paddingTop);
    }

    /**
     * @return int
     */
    public function getPaddingRight()
    {
        return $this->padding->getRight();
    }

    /**
     * @param int $paddingRight
     */
    public function setPaddingRight($paddingRight)
    {
        $this->padding->setRight($paddingRight);
    }

    /**
     * @return int
     */
    public function getPaddingBottom()
    {
        return $this->padding->getBottom();
    }

    /**
     * @param int $paddingBottom
     */
    public function setPaddingBottom($paddingBottom)
    {
        $this->padding->setBottom($paddingBottom);
    }

    /**
     * @return int
     */
    public function getPaddingLeft()
    {
        return $this->padding->getLeft();
    }

    /**
     * @param int $paddingLeft
     */
    public function setPaddingLeft($paddingLeft)
    {
        $this->padding->setLeft($paddingLeft);
    }

    /**
     * @return array
     */
    public function getPadding()
    {
        return $this->padding->toArray();
    }
}