<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Weave\Style\ShadowStyle;

trait ShadowAwareTrait
{

    /**
     * @var ShadowStyle
     * @ODM\EmbedOne(targetDocument="Rc\Domain\Model\Research\Exposition\Weave\Style\ShadowStyle")
     */
    protected $shadow;

    /**
     * @return int
     */
    public function getShadowMarginTop()
    {
        return $this->shadow->getMarginTop();
    }

    /**
     * @param int $marginTop
     */
    public function setShadowMarginTop($marginTop)
    {
        $this->shadow->setMarginTop($marginTop);
    }

    /**
     * @return int
     */
    public function getShadowMarginLeft()
    {
        return $this->shadow->getMarginLeft();
    }

    /**
     * @param int $marginLeft
     */
    public function setShadowMarginLeft($marginLeft)
    {
        $this->shadow->setMarginLeft($marginLeft);
    }

    /**
     * @return int
     */
    public function getShadowBlur()
    {
        return $this->shadow->getBlur();
    }

    /**
     * @param int $blur
     */
    public function setShadowBlur($blur)
    {
        $this->shadow->setBlur($blur);
    }

    /**
     * @deprecated
     * @return int
     */
    public function getShadowUnschaerfe()
    {
        return $this->getShadowBlur();
    }

    /**
     * @deprecated
     * @param int $shadowBlur
     */
    public function setShadowUnschaerfe($shadowBlur)
    {
        $this->setShadowBlur($shadowBlur);
    }

    /**
     * @return string
     */
    public function getShadowColor()
    {
        return $this->shadow->getColor();
    }

    /**
     * @param string $color
     */
    public function setShadowColor($color)
    {
        $this->shadow->setColor($color);
    }
}