<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Style;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\EmbeddedDocument
 */
class PositionStyle
{

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $top;

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $right;

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $bottom;

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $left;

    /**
     * @return int
     */
    public function getTop()
    {
        return $this->top;
    }

    /**
     * @param int $top
     * @return void
     */
    public function setTop($top)
    {
        $this->top = (int)$top;
    }

    /**
     * @return int
     */
    public function getRight()
    {
        return $this->right;
    }

    /**
     * @param int $right
     * @return void
     */
    public function setRight($right)
    {
        $this->right = (int)$right;
    }

    /**
     * @return int
     */
    public function getBottom()
    {
        return $this->bottom;
    }

    /**
     * @param int $bottom
     * @return void
     */
    public function setBottom($bottom)
    {
        $this->bottom = (int)$bottom;
    }

    /**
     * @return int
     */
    public function getLeft()
    {
        return $this->left;
    }

    /**
     * @param int $left
     * @return void
     */
    public function setLeft($left)
    {
        $this->left = (int)$left;
    }

    /**
     * @return array
     */
    public function toArray()
    {
        return [
            'top'    => $this->top,
            'right'  => $this->right,
            'bottom' => $this->bottom,
            'left'   => $this->left,
        ];
    }

}