<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Style;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\EmbeddedDocument
 */
class ShadowStyle
{

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $marginTop;

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $marginLeft;

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $blur;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $color;

    /**
     * @return int
     */
    public function getMarginTop()
    {
        return $this->marginTop;
    }

    /**
     * @param int $marginTop
     * @return void
     */
    public function setMarginTop($marginTop)
    {
        $this->marginTop = $marginTop;
    }

    /**
     * @return int
     */
    public function getMarginLeft()
    {
        return $this->marginLeft;
    }

    /**
     * @param int $marginLeft
     * @return void
     */
    public function setMarginLeft($marginLeft)
    {
        $this->marginLeft = $marginLeft;
    }

    /**
     * @return int
     */
    public function getBlur()
    {
        return $this->blur;
    }

    /**
     * @param int $blur
     * @return void
     */
    public function setBlur($blur)
    {
        $this->blur = $blur;
    }

    /**
     * @return string
     */
    public function getColor()
    {
        return $this->color;
    }

    /**
     * @param string $color
     * @return void
     */
    public function setColor($color)
    {
        $this->color = $color;
    }

}