<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic;

trait AspectRatioAwareTrait
{

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $fixAspectRatio = true;

    public function enforceAspectRatio()
    {
        if (!$this->hasMedia()) {
            return;
        }

        $mediaResolution = $this->getMedia()->getMediaResolution();
        if (!isset($mediaResolution) || !$mediaResolution->hasAspectRatio()) {
            return;
        }

        $this->setHeight($this->getWidth() / $mediaResolution->getAspectRatio());
    }

    /**
     * @return boolean
     */
    public function isFixAspectRatio()
    {
        return $this->fixAspectRatio;
    }

    /**
     * @param boolean $fixAspectRatio
     * @return $this
     */
    public function setFixAspectRatio($fixAspectRatio)
    {
        $this->fixAspectRatio = $fixAspectRatio;
        return $this;
    }
}