<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Weave\Shape\PlayerShape;

trait PlayerAwareTrait
{
    /**
     * @var PlayerShape
     * @ODM\EmbedOne(targetDocument="Rc\Domain\Model\Research\Exposition\Weave\Shape\PlayerShape")
     */
    protected $player;

    /**
     * @return boolean
     */
    public function isLoop()
    {
        return $this->player->isLoop();
    }

    /**
     * @deprecated
     * @return bool
     */
    public function getLoop()
    {
        return $this->isLoop();
    }

    /**
     * @param boolean $loop
     */
    public function setLoop($loop)
    {
        $this->player->setLoop($loop);
    }

    /**
     * @return boolean
     */
    public function isAutoPlay()
    {
        return $this->player->isAutoPlay();
    }

    /**
     * @deprecated
     * @return bool
     */
    public function getAutoPlay()
    {
        return $this->isAutoPlay();
    }

    /**
     * @param boolean $autoPlay
     */
    public function setAutoPlay($autoPlay)
    {
        $this->player->setAutoPlay($autoPlay);
    }

    /**
     * @return boolean
     */
    public function isDisplayVolume()
    {
        return $this->player->isDisplayVolume();
    }

    /**
     * @deprecated
     * @return bool
     */
    public function getDisplayVolume()
    {
        return $this->isDisplayVolume();
    }

    /**
     * @param boolean $displayVolume
     */
    public function setDisplayVolume($displayVolume)
    {
        $this->player->setDisplayVolume($displayVolume);
    }

    /**
     * @return boolean
     */
    public function isDisplayMinimal()
    {
        return $this->player->isDisplayMinimal();
    }

    /**
     * @deprecated
     * @return bool
     */
    public function getDisplayMinimal()
    {
        return $this->isDisplayMinimal();
    }

    /**
     * @param boolean $displayMinimal
     */
    public function setDisplayMinimal($displayMinimal)
    {
        $this->player->setDisplayMinimal($displayMinimal);
    }

    /**
     * @return boolean
     */
    public function isHidePlayer()
    {
        return $this->player->isHidePlayer();
    }

    /**
     * @deprecated
     * @return bool
     */
    public function getHidePlayer()
    {
        return $this->isHidePlayer();
    }

    /**
     * @param boolean $hidePlayer
     */
    public function setHidePlayer($hidePlayer)
    {
        $this->player->setHidePlayer($hidePlayer);
    }

    /**
     * @return boolean
     */
    public function isStopOtherPlayers()
    {
        return $this->player->isStopOtherPlayers();
    }

    /**
     * @deprecated
     * @return bool
     */
    public function getStopOtherPlayers()
    {
        return $this->isStopOtherPlayers();
    }

    /**
     * @param boolean $stopOtherPlayers
     */
    public function setStopOtherPlayers($stopOtherPlayers)
    {
        $this->player->setStopOtherPlayers($stopOtherPlayers);
    }
}