<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Media\MediaType;
use Rc\Domain\Model\Research\Exposition\Generic\ThreeDimensionalAwareInterface;
use Rc\Domain\Model\Research\Exposition\Weave\Tool;

/**
 * @ODM\Document
 */
class ObjectviewerTool extends Tool implements ThreeDimensionalAwareInterface
{

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $levels;

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $startLevel;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $autoRotate;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $displayInBrowser;

    /**
     * @return array
     */
    public function getSupportedMediaTypes()
    {
        return [
            MediaType::ARCHIVE,
        ];
    }

    /**
     * @return boolean
     */
    public function isAutoRotate()
    {
        return $this->autoRotate;
    }

    /**
     * @return boolean
     */
    public function getAutoRotate()
    {
        return $this->isAutoRotate();
    }

    /**
     * @param boolean $autoRotate
     */
    public function setAutoRotate($autoRotate)
    {
        $this->autoRotate = $autoRotate;
    }

    /**
     * @return int
     */
    public function getStartLevel()
    {
        return $this->startLevel;
    }

    /**
     * @param int $startLevel
     */
    public function setStartLevel($startLevel)
    {
        $this->startLevel = $startLevel;
    }

    /**
     * @return int
     */
    public function getLevels()
    {
        return $this->levels;
    }

    /**
     * @param int $levels
     */
    public function setLevels($levels)
    {
        $this->levels = $levels;
    }
}