<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\AbstractModel;
use Rc\Domain\Model\Research;

/**
 * @ODM\Document
 */
class Snapshot extends AbstractModel
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $name;

    /**
     * @var Research
     * @ODM\ReferenceOne(targetDocument="Rc\Domain\Model\Research", storeAs="dbRef")
     */
    protected $research;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $snapshot;

    /**
     * @param Research $research
     * @param string $snapshot
     */
    public function __construct(Research $research, $snapshot)
    {
        parent::__construct();

        $this->research = $research;
        $this->snapshot = $snapshot;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return Research
     */
    public function getResearch()
    {
        return $this->research;
    }

    /**
     * @return string
     */
    public function getSnapshot()
    {
        return $this->snapshot;
    }

}
