<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Repository;

class LogRepository extends MongoRepository
{

    /**
     * @param string $type
     * @param array $data
     */
    public static function add($type, array $data)
    {
        MongoRepository::getClient()->getConnection()
            ->selectCollection(self::getDb(), $type)
            ->insert($data);
    }

    /**
     * @param string $type
     * @param array $query
     * @param array $data
     */
    public static function update($type, array $query, array $data)
    {
        $collection = MongoRepository::getClient()->getConnection()
            ->selectCollection(self::getDb(), $type);

        $result = $collection->createQueryBuilder()
            ->setQueryArray($query)
            ->limit(1)
            ->getQuery()
            ->execute()
            ->toArray(false);

        $existingData = array_shift($result) ?: [];

        $collection->upsert($query, array_merge($existingData, $data));
    }

    /**
     * @return string
     */
    public static function getDb()
    {
        return parent::getDb() . '_log';
    }
}

