<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Service\Madek;

use Identity;
use Rc\Domain\Model\User\Setting\MadekRepository;
use Rc\Service\MadekService;

class MadekServiceFactory
{

    /**
     * @return MadekService
     * @throws \Exception
     */
    public static function create()
    {
        /** @var MadekRepository $madekRepository */
        $madekRepository = Identity::getUser()->getSettings()->getRepository(MadekRepository::class);

        if (isset($madekRepository)) {
            $options = ['auth' => ['', $madekRepository->getToken()]];
        } else {
            $options = [];
        }

        return new MadekService($options);
    }
}