<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Utility;

use MaxMind\Db\Reader;

class GeoIp
{

    /**
     * @var Reader
     */
    private static $reader;

    /**
     * @param string $ip
     * @return string|null
     */
    public static function country(string $ip): ?string
    {
        try {
            return static::reader()->get($ip)['country']['iso_code'];
        } catch (\Exception $exception) {
            return null;
        }
    }

    /**
     * @return Reader
     * @throws Reader\InvalidDatabaseException
     */
    private static function reader(): Reader
    {
        if (!isset(static::$reader)) {
            static::$reader = new Reader(config('services.geoip.database'));
        }

        return static::$reader;
    }
}