<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Utility;

use Rc\Domain\Model\ModelInterface;

class TokenGenerator
{

    /**
     * @param string $input
     * @return string
     */
    public static function generate($input)
    {
        return self::salt($input);
    }

    /**
     * @param ModelInterface $model
     * @return string
     */
    public static function generateForModel(ModelInterface $model)
    {
        return self::salt($model->getUuid());
    }

    /**
     * @param string $input
     * @return string
     */
    protected static function salt($input)
    {
        return md5(config('app.salt_token') . $input);
    }
}