<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Utility;

use Rc\Domain\Model\Core\Revision\RevisionFactory;
use Rc\Domain\Model\Research\Exposition\Weave\Tool;
use Rc\Domain\Model\Research\Exposition\Weave\ToolInterface;
use Rc\Domain\Repository\Core\RevisionRepository;
use Rc\Domain\Repository\Research\Exposition\Weave\ToolRepository;

class ToolService
{

    /**
     * @param string $revisionId
     * @return ToolInterface
     */
    public function restore($revisionId)
    {
        $revision = RevisionRepository::findById($revisionId);

        /** @var Tool $tool */
        $tool = $revision->getDocument();

        if ($revision->getLabel() == 'delete') {
            RevisionRepository::remove($revision);
        }

        RevisionFactory::create($revision, 'restore');

        return ToolRepository::merge($tool);
    }
}